clear
set logtype t
set more off
set mem 48m
set matsize 800
cap log close

capture program drop archboot
    program define archboot
            version 7.0
            if "`1'" == "?"   {
			#delimit;
                    global S_1 "inter1  inter2  inter3  inter4  inter5  inter6  inter7  inter8  inter9  inter10
					  inter11 inter12 inter13 inter14 inter15 inter16 inter17 inter18 inter19 inter20
					  inter21 main";
			#delimit cr
                    exit
			            }
			ivreg ly (ly1 ly1_*=ly4*) yrd* age* wh* regd* rg* bigsmsa sms*
			
			gen inter1 =_b[ly1_72]
			gen inter2 =_b[ly1_73]
			gen inter3 =_b[ly1_74]
			gen inter4 =_b[ly1_75]
			gen inter5 =_b[ly1_76]
			gen inter6 =_b[ly1_77]
			gen inter7 =_b[ly1_78]
			gen inter8 =_b[ly1_79]
			gen inter9 =_b[ly1_80]
			gen inter10=_b[ly1_81]
			gen inter11=_b[ly1_82]
			gen inter12=_b[ly1_83]
			gen inter13=_b[ly1_84]
			gen inter14=_b[ly1_85]
			gen inter15=_b[ly1_86]
			gen inter16=_b[ly1_87]
			gen inter17=_b[ly1_88]
			gen inter18=_b[ly1_89]
			gen inter19=_b[ly1_90]
			gen inter20=_b[ly1_91]
			gen inter21=_b[ly1_92]
			gen main   =_b[ly1]

			su inter1 ,d
			local INTER1  = _result(3)
			su inter2 ,d
			local INTER2  = _result(3)
			su inter3 ,d
			local INTER3  = _result(3)
			su inter4 ,d
			local INTER4  = _result(3)
			su inter5 ,d
			local INTER5  = _result(3)
			su inter6 ,d
			local INTER6  = _result(3)
			su inter7 ,d
			local INTER7  = _result(3)
			su inter8 ,d
			local INTER8  = _result(3)
			su inter9 ,d
			local INTER9  = _result(3)
			su inter10,d
			local INTER10 = _result(3)
			su inter11,d
			local INTER11 = _result(3)
			su inter12,d
			local INTER12 = _result(3)
			su inter13,d
			local INTER13 = _result(3)
			su inter14,d
			local INTER14 = _result(3)
			su inter15,d
			local INTER15 = _result(3)
			su inter16,d
			local INTER16 = _result(3)
			su inter17,d
			local INTER17 = _result(3)
			su inter18,d
			local INTER18 = _result(3)
			su inter19,d
			local INTER19 = _result(3)
			su inter20,d
			local INTER20 = _result(3)
			su inter21,d
			local INTER21 = _result(3)
            	su main,d
			local MAIN = _result(3)

			#delimit;    
			post `1' (`INTER1') (`INTER2') (`INTER3') (`INTER4') (`INTER5') (`INTER6') (`INTER7') (`INTER8') 
				   (`INTER9') (`INTER10') (`INTER11') (`INTER12') (`INTER13') (`INTER14') (`INTER15') (`INTER16')
    				   (`INTER17') (`INTER18') (`INTER19') (`INTER20') (`INTER21') (`MAIN');
			#delimit cr
end

use vit4xboot, clear
set seed 100001
sort newid year
qui by newid:gen ly1=ly[_n-1]
qui by newid:gen ly4=ly[_n-4]

gen ly1_72=ly1*yrd6
gen ly1_73=ly1*yrd7
gen ly1_74=ly1*yrd8
gen ly1_75=ly1*yrd9
gen ly1_76=ly1*yrd10
gen ly1_77=ly1*yrd11
gen ly1_78=ly1*yrd12
gen ly1_79=ly1*yrd13
gen ly1_80=ly1*yrd14
gen ly1_81=ly1*yrd15
gen ly1_82=ly1*yrd16
gen ly1_83=ly1*yrd17
gen ly1_84=ly1*yrd18
gen ly1_85=ly1*yrd19
gen ly1_86=ly1*yrd20
gen ly1_87=ly1*yrd21
gen ly1_88=ly1*yrd22
gen ly1_89=ly1*yrd23
gen ly1_90=ly1*yrd24
gen ly1_91=ly1*yrd25
gen ly1_92=ly1*yrd26

cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen ly4_`i'=ly4*yrd`i'
		gen age_`i'=age*yrd`i'
		gen age2_`i'=age2*yrd`i'
		gen wh_`i'=white*yrd`i'
		gen rg1_`i'=regd1*yrd`i'
		gen rg2_`i'=regd2*yrd`i'
		gen rg3_`i'=regd3*yrd`i'
		gen rg4_`i'=regd4*yrd`i'
		gen sms_`i'=bigsmsa*yrd`i' 
        local i=`i'+1
                }
end
qui doit

bstrap archboot, reps(100) cluster(newid) idcluster(idboot) dots saving(archboot0) replace every(5)
clear


use vit4xboot, clear
keep if studio==1
set seed 100001
sort newid year
qui by newid:gen ly1=ly[_n-1]
qui by newid:gen ly4=ly[_n-4]

gen ly1_72=ly1*yrd6
gen ly1_73=ly1*yrd7
gen ly1_74=ly1*yrd8
gen ly1_75=ly1*yrd9
gen ly1_76=ly1*yrd10
gen ly1_77=ly1*yrd11
gen ly1_78=ly1*yrd12
gen ly1_79=ly1*yrd13
gen ly1_80=ly1*yrd14
gen ly1_81=ly1*yrd15
gen ly1_82=ly1*yrd16
gen ly1_83=ly1*yrd17
gen ly1_84=ly1*yrd18
gen ly1_85=ly1*yrd19
gen ly1_86=ly1*yrd20
gen ly1_87=ly1*yrd21
gen ly1_88=ly1*yrd22
gen ly1_89=ly1*yrd23
gen ly1_90=ly1*yrd24
gen ly1_91=ly1*yrd25
gen ly1_92=ly1*yrd26

cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen ly4_`i'=ly4*yrd`i'
		gen age_`i'=age*yrd`i'
		gen age2_`i'=age2*yrd`i'
		gen wh_`i'=white*yrd`i'
		gen rg1_`i'=regd1*yrd`i'
		gen rg2_`i'=regd2*yrd`i'
		gen rg3_`i'=regd3*yrd`i'
		gen rg4_`i'=regd4*yrd`i'
		gen sms_`i'=bigsmsa*yrd`i' 
        local i=`i'+1
                }
end
qui doit

bstrap archboot, reps(100) cluster(newid) idcluster(idboot) dots saving(archboot1) replace every(5)
clear


use vit4xboot, clear
keep if studio==2
set seed 100001
sort newid year
qui by newid:gen ly1=ly[_n-1]
qui by newid:gen ly4=ly[_n-4]

gen ly1_72=ly1*yrd6
gen ly1_73=ly1*yrd7
gen ly1_74=ly1*yrd8
gen ly1_75=ly1*yrd9
gen ly1_76=ly1*yrd10
gen ly1_77=ly1*yrd11
gen ly1_78=ly1*yrd12
gen ly1_79=ly1*yrd13
gen ly1_80=ly1*yrd14
gen ly1_81=ly1*yrd15
gen ly1_82=ly1*yrd16
gen ly1_83=ly1*yrd17
gen ly1_84=ly1*yrd18
gen ly1_85=ly1*yrd19
gen ly1_86=ly1*yrd20
gen ly1_87=ly1*yrd21
gen ly1_88=ly1*yrd22
gen ly1_89=ly1*yrd23
gen ly1_90=ly1*yrd24
gen ly1_91=ly1*yrd25
gen ly1_92=ly1*yrd26

cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen ly4_`i'=ly4*yrd`i'
		gen age_`i'=age*yrd`i'
		gen age2_`i'=age2*yrd`i'
		gen wh_`i'=white*yrd`i'
		gen rg1_`i'=regd1*yrd`i'
		gen rg2_`i'=regd2*yrd`i'
		gen rg3_`i'=regd3*yrd`i'
		gen rg4_`i'=regd4*yrd`i'
		gen sms_`i'=bigsmsa*yrd`i' 
        local i=`i'+1
                }
end
qui doit

bstrap archboot, reps(100) cluster(newid) idcluster(idboot) dots saving(archboot2) replace every(5)
clear


use vit4xboot, clear
keep if studio==3
set seed 100001
sort newid year
qui by newid:gen ly1=ly[_n-1]
qui by newid:gen ly4=ly[_n-4]

gen ly1_72=ly1*yrd6
gen ly1_73=ly1*yrd7
gen ly1_74=ly1*yrd8
gen ly1_75=ly1*yrd9
gen ly1_76=ly1*yrd10
gen ly1_77=ly1*yrd11
gen ly1_78=ly1*yrd12
gen ly1_79=ly1*yrd13
gen ly1_80=ly1*yrd14
gen ly1_81=ly1*yrd15
gen ly1_82=ly1*yrd16
gen ly1_83=ly1*yrd17
gen ly1_84=ly1*yrd18
gen ly1_85=ly1*yrd19
gen ly1_86=ly1*yrd20
gen ly1_87=ly1*yrd21
gen ly1_88=ly1*yrd22
gen ly1_89=ly1*yrd23
gen ly1_90=ly1*yrd24
gen ly1_91=ly1*yrd25
gen ly1_92=ly1*yrd26

cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen ly4_`i'=ly4*yrd`i'
		gen age_`i'=age*yrd`i'
		gen age2_`i'=age2*yrd`i'
		gen wh_`i'=white*yrd`i'
		gen rg1_`i'=regd1*yrd`i'
		gen rg2_`i'=regd2*yrd`i'
		gen rg3_`i'=regd3*yrd`i'
		gen rg4_`i'=regd4*yrd`i'
		gen sms_`i'=bigsmsa*yrd`i' 
        local i=`i'+1
                }
end
qui doit

bstrap archboot, reps(100) cluster(newid) idcluster(idboot) dots saving(archboot3) replace every(5)
clear

****Warning: archboot0 (whole sample) has never been done, Costas took archboot1+archboot2+archboot3 and got the test (I don't know how)
****This means: "gen maina   =((main   -.xxxxxxx)/r(sd))^2" must take the .xxxxx values from the regression above (the one for the 
****whole sample).
WARNING!!!!

/*
u archboot0,clear

*********Critical values bootstrap

qui su main
gen maina   =((main   -.xxxxxxx)/r(sd))^2
qui su inter1
gen inter1a =((inter1 -.3249240)/r(sd))^2
qui su inter2
gen inter2a =((inter2 -.0860442)/r(sd))^2 
qui su inter3
gen inter3a =((inter3 -.3036765)/r(sd))^2 
qui su inter4
gen inter4a =((inter4 -.3177577)/r(sd))^2 
qui su inter5
gen inter5a =((inter5 -.4151702)/r(sd))^2 
qui su inter6
gen inter6a =((inter6 -.1406310)/r(sd))^2 
qui su inter7
gen inter7a =((inter7 -.3021663)/r(sd))^2 
qui su inter8
gen inter8a =((inter8 -.2260736)/r(sd))^2 
qui su inter9
gen inter9a =((inter9 -.1806884)/r(sd))^2 
qui su inter10
gen inter10a=((inter10-.3374532)/r(sd))^2 
qui su inter11
gen inter11a=((inter11-.3433337)/r(sd))^2 
qui su inter12
gen inter12a=((inter12-.3121287)/r(sd))^2 
qui su inter13
gen inter13a=((inter13-.3586952)/r(sd))^2 
qui su inter14
gen inter14a=((inter14-.1887213)/r(sd))^2 
qui su inter15
gen inter15a=((inter15-.1434086)/r(sd))^2 
qui su inter16
gen inter16a=((inter16-.3136575)/r(sd))^2 
qui su inter17
gen inter17a=((inter17-.2062356)/r(sd))^2 
qui su inter18
gen inter18a=((inter18-.2320251)/r(sd))^2 
qui su inter19
gen inter19a=((inter19-.3653721)/r(sd))^2 
qui su inter20
gen inter20a=((inter20-.0951515)/r(sd))^2 
qui su inter21
gen inter21a=((inter21-.4258739)/r(sd))^2 

#delimit;
gen sum=maina+inter1a+inter2a+inter3a+inter4a+inter5a+inter6a+inter7a+inter8a+inter9a+inter10a+
        inter11a+inter12a+inter13a+inter14a+inter15a+inter16a+inter17a+inter18a+inter19a+inter20a+
        inter21a;
#delimit cr

drop maina-inter21a

qui su main
replace main   =((.7407523-1)/r(sd))^2
qui su inter1
replace inter1 =((.3249240)/r(sd))^2
qui su inter2
replace inter2 =((.0860442)/r(sd))^2 
qui su inter3
replace inter3 =((.3036765)/r(sd))^2 
qui su inter4
replace inter4 =((.3177577)/r(sd))^2 
qui su inter5
replace inter5 =((.4151702)/r(sd))^2 
qui su inter6
replace inter6 =((.1406310)/r(sd))^2 
qui su inter7
replace inter7 =((.3021663)/r(sd))^2 
qui su inter8
replace inter8 =((.2260736)/r(sd))^2 
qui su inter9
replace inter9 =((.1806884)/r(sd))^2 
qui su inter10
replace inter10=((.3374532)/r(sd))^2 
qui su inter11
replace inter11=((.3433337)/r(sd))^2 
qui su inter12
replace inter12=((.3121287)/r(sd))^2 
qui su inter13
replace inter13=((.3586952)/r(sd))^2 
qui su inter14
replace inter14=((.1887213)/r(sd))^2 
qui su inter15
replace inter15=((.1434086)/r(sd))^2 
qui su inter16
replace inter16=((.3136575)/r(sd))^2 
qui su inter17
replace inter17=((.2062356)/r(sd))^2 
qui su inter18
replace inter18=((.2320251)/r(sd))^2 
qui su inter19
replace inter19=((.3653721)/r(sd))^2 
qui su inter20
replace inter20=((.0951515)/r(sd))^2 
qui su inter21
replace inter21=((.4258739)/r(sd))^2 

#delimit;
gen tstat=main+inter1+inter2+inter3+inter4+inter5+inter6+inter7+inter8+inter9+inter10+
        inter11+inter12+inter13+inter14+inter15+inter16+inter17+inter18+inter19+inter20+
        inter21;
#delimit cr

gsort -sum

keep sum tstat
save joint0,replace
clear
*/


u archboot1,clear

*********Critical values bootstrap

qui su main
gen maina   =((main   -.7407523)/r(sd))^2
qui su inter1
gen inter1a =((inter1 -.3249240)/r(sd))^2
qui su inter2
gen inter2a =((inter2 -.0860442)/r(sd))^2 
qui su inter3
gen inter3a =((inter3 -.3036765)/r(sd))^2 
qui su inter4
gen inter4a =((inter4 -.3177577)/r(sd))^2 
qui su inter5
gen inter5a =((inter5 -.4151702)/r(sd))^2 
qui su inter6
gen inter6a =((inter6 -.1406310)/r(sd))^2 
qui su inter7
gen inter7a =((inter7 -.3021663)/r(sd))^2 
qui su inter8
gen inter8a =((inter8 -.2260736)/r(sd))^2 
qui su inter9
gen inter9a =((inter9 -.1806884)/r(sd))^2 
qui su inter10
gen inter10a=((inter10-.3374532)/r(sd))^2 
qui su inter11
gen inter11a=((inter11-.3433337)/r(sd))^2 
qui su inter12
gen inter12a=((inter12-.3121287)/r(sd))^2 
qui su inter13
gen inter13a=((inter13-.3586952)/r(sd))^2 
qui su inter14
gen inter14a=((inter14-.1887213)/r(sd))^2 
qui su inter15
gen inter15a=((inter15-.1434086)/r(sd))^2 
qui su inter16
gen inter16a=((inter16-.3136575)/r(sd))^2 
qui su inter17
gen inter17a=((inter17-.2062356)/r(sd))^2 
qui su inter18
gen inter18a=((inter18-.2320251)/r(sd))^2 
qui su inter19
gen inter19a=((inter19-.3653721)/r(sd))^2 
qui su inter20
gen inter20a=((inter20-.0951515)/r(sd))^2 
qui su inter21
gen inter21a=((inter21-.4258739)/r(sd))^2 

#delimit;
gen sum=maina+inter1a+inter2a+inter3a+inter4a+inter5a+inter6a+inter7a+inter8a+inter9a+inter10a+
        inter11a+inter12a+inter13a+inter14a+inter15a+inter16a+inter17a+inter18a+inter19a+inter20a+
        inter21a;
#delimit cr

drop maina-inter21a

qui su main
replace main   =((.7407523-1)/r(sd))^2
qui su inter1
replace inter1 =((.3249240)/r(sd))^2
qui su inter2
replace inter2 =((.0860442)/r(sd))^2 
qui su inter3
replace inter3 =((.3036765)/r(sd))^2 
qui su inter4
replace inter4 =((.3177577)/r(sd))^2 
qui su inter5
replace inter5 =((.4151702)/r(sd))^2 
qui su inter6
replace inter6 =((.1406310)/r(sd))^2 
qui su inter7
replace inter7 =((.3021663)/r(sd))^2 
qui su inter8
replace inter8 =((.2260736)/r(sd))^2 
qui su inter9
replace inter9 =((.1806884)/r(sd))^2 
qui su inter10
replace inter10=((.3374532)/r(sd))^2 
qui su inter11
replace inter11=((.3433337)/r(sd))^2 
qui su inter12
replace inter12=((.3121287)/r(sd))^2 
qui su inter13
replace inter13=((.3586952)/r(sd))^2 
qui su inter14
replace inter14=((.1887213)/r(sd))^2 
qui su inter15
replace inter15=((.1434086)/r(sd))^2 
qui su inter16
replace inter16=((.3136575)/r(sd))^2 
qui su inter17
replace inter17=((.2062356)/r(sd))^2 
qui su inter18
replace inter18=((.2320251)/r(sd))^2 
qui su inter19
replace inter19=((.3653721)/r(sd))^2 
qui su inter20
replace inter20=((.0951515)/r(sd))^2 
qui su inter21
replace inter21=((.4258739)/r(sd))^2 

#delimit;
gen tstat=main+inter1+inter2+inter3+inter4+inter5+inter6+inter7+inter8+inter9+inter10+
        inter11+inter12+inter13+inter14+inter15+inter16+inter17+inter18+inter19+inter20+
        inter21;
#delimit cr

gsort -sum

keep sum tstat
save joint1,replace
clear


u archboot2,clear

*********Critical values bootstrap

qui su main
gen maina   =((main   - .9344497)/r(sd))^2
qui su inter1
gen inter1a =((inter1 - .0641123)/r(sd))^2
qui su inter2
gen inter2a =((inter2 - .0530643)/r(sd))^2 
qui su inter3
gen inter3a =((inter3 - .1678329)/r(sd))^2 
qui su inter4
gen inter4a =((inter4 - .0077531)/r(sd))^2 
qui su inter5
gen inter5a =((inter5 - .1300008)/r(sd))^2 
qui su inter6
gen inter6a =((inter6 - .0023826)/r(sd))^2 
qui su inter7
gen inter7a =((inter7 -  .050756)/r(sd))^2 
qui su inter8
gen inter8a =((inter8 + .0578164)/r(sd))^2 
qui su inter9
gen inter9a =((inter9 - .0767755)/r(sd))^2 
qui su inter10
gen inter10a=((inter10+ .0349695)/r(sd))^2 
qui su inter11
gen inter11a=((inter11- .1061672)/r(sd))^2 
qui su inter12
gen inter12a=((inter12- .2049591)/r(sd))^2 
qui su inter13
gen inter13a=((inter13+  .053432)/r(sd))^2 
qui su inter14
gen inter14a=((inter14-  .063348)/r(sd))^2 
qui su inter15
gen inter15a=((inter15- .0205493)/r(sd))^2 
qui su inter16
gen inter16a=((inter16- .0239152)/r(sd))^2 
qui su inter17
gen inter17a=((inter17+ .0285882)/r(sd))^2 
qui su inter18
gen inter18a=((inter18+ .0243654)/r(sd))^2 
qui su inter19
gen inter19a=((inter19-   .07671)/r(sd))^2 
qui su inter20
gen inter20a=((inter20- .0528847)/r(sd))^2 
qui su inter21
gen inter21a=((inter21+ .0698134)/r(sd))^2 

#delimit;
gen sum=maina+inter1a+inter2a+inter3a+inter4a+inter5a+inter6a+inter7a+inter8a+inter9a+inter10a+
        inter11a+inter12a+inter13a+inter14a+inter15a+inter16a+inter17a+inter18a+inter19a+inter20a+
        inter21a;
#delimit cr

drop maina-inter21a

qui su main
gen maina   =((.9344497-1)/r(sd))^2
qui su inter1
gen inter1a =((.0641123)/r(sd))^2
qui su inter2
gen inter2a =((.0530643)/r(sd))^2 
qui su inter3
gen inter3a =((.1678329)/r(sd))^2 
qui su inter4
gen inter4a =((.0077531)/r(sd))^2 
qui su inter5
gen inter5a =((.1300008)/r(sd))^2 
qui su inter6
gen inter6a =((.0023826)/r(sd))^2 
qui su inter7
gen inter7a =((.050756)/r(sd))^2 
qui su inter8
gen inter8a =((.0578164)/r(sd))^2 
qui su inter9
gen inter9a =((.0767755)/r(sd))^2 
qui su inter10
gen inter10a=((.0349695)/r(sd))^2 
qui su inter11
gen inter11a=((.1061672)/r(sd))^2 
qui su inter12
gen inter12a=((.2049591)/r(sd))^2 
qui su inter13
gen inter13a=((.053432)/r(sd))^2 
qui su inter14
gen inter14a=((.063348)/r(sd))^2 
qui su inter15
gen inter15a=((.0205493)/r(sd))^2 
qui su inter16
gen inter16a=((.0239152)/r(sd))^2 
qui su inter17
gen inter17a=((.0285882)/r(sd))^2 
qui su inter18
gen inter18a=((.0243654)/r(sd))^2 
qui su inter19
gen inter19a=((.07671)/r(sd))^2 
qui su inter20
gen inter20a=((.0528847)/r(sd))^2 
qui su inter21
gen inter21a=((.0698134)/r(sd))^2 

#delimit;
gen tstat=maina+inter1a+inter2a+inter3a+inter4a+inter5a+inter6a+inter7a+inter8a+inter9a+inter10a+
        inter11a+inter12a+inter13a+inter14a+inter15a+inter16a+inter17a+inter18a+inter19a+inter20a+
        inter21a;
#delimit cr

gsort -sum
keep sum tstat
save joint2,replace

u archboot3,clear

*********Critical values bootstrap


qui su main
gen maina   =((main   -  .915041 )/r(sd))^2
qui su inter1
gen inter1a =((inter1 - .0878574 )/r(sd))^2
qui su inter2
gen inter2a =((inter2 - .0037229 )/r(sd))^2 
qui su inter3
gen inter3a =((inter3 - .0305551 )/r(sd))^2 
qui su inter4
gen inter4a =((inter4 - .0711471 )/r(sd))^2 
qui su inter5
gen inter5a =((inter5 -  .045983 )/r(sd))^2 
qui su inter6
gen inter6a =((inter6 -  .082007 )/r(sd))^2 
qui su inter7
gen inter7a =((inter7 - .0854275 )/r(sd))^2 
qui su inter8
gen inter8a =((inter8 - .0776773 )/r(sd))^2 
qui su inter9
gen inter9a =((inter9 - .0796564 )/r(sd))^2 
qui su inter10
gen inter10a=((inter10- .0169305 )/r(sd))^2 
qui su inter11
gen inter11a=((inter11- .0143305 )/r(sd))^2 
qui su inter12
gen inter12a=((inter12- .2208714 )/r(sd))^2 
qui su inter13
gen inter13a=((inter13-  .152781 )/r(sd))^2 
qui su inter14
gen inter14a=((inter14+ .0441672 )/r(sd))^2 
qui su inter15
gen inter15a=((inter15-  .133929 )/r(sd))^2 
qui su inter16
gen inter16a=((inter16- .0363273 )/r(sd))^2 
qui su inter17
gen inter17a=((inter17-  .021152 )/r(sd))^2 
qui su inter18
gen inter18a=((inter18- .1019488 )/r(sd))^2 
qui su inter19
gen inter19a=((inter19- .1136377 )/r(sd))^2 
qui su inter20
gen inter20a=((inter20- .0108418 )/r(sd))^2 
qui su inter21
gen inter21a=((inter21- .0337012 )/r(sd))^2 

#delimit;
gen sum=maina+inter1a+inter2a+inter3a+inter4a+inter5a+inter6a+inter7a+inter8a+inter9a+inter10a+
        inter11a+inter12a+inter13a+inter14a+inter15a+inter16a+inter17a+inter18a+inter19a+inter20a+
        inter21a;
#delimit cr

drop maina-inter21a

qui su main
gen maina   =((.915041-1)/r(sd))^2
qui su inter1
gen inter1a =((.0878574 )/r(sd))^2
qui su inter2
gen inter2a =((.0037229 )/r(sd))^2 
qui su inter3
gen inter3a =((.0305551 )/r(sd))^2 
qui su inter4
gen inter4a =((.0711471 )/r(sd))^2 
qui su inter5
gen inter5a =((.045983 )/r(sd))^2 
qui su inter6
gen inter6a =((.082007 )/r(sd))^2 
qui su inter7
gen inter7a =((.0854275 )/r(sd))^2 
qui su inter8
gen inter8a =((.0776773 )/r(sd))^2 
qui su inter9
gen inter9a =((.0796564 )/r(sd))^2 
qui su inter10
gen inter10a=((.0169305 )/r(sd))^2 
qui su inter11
gen inter11a=((.0143305 )/r(sd))^2 
qui su inter12
gen inter12a=((.2208714 )/r(sd))^2 
qui su inter13
gen inter13a=((.152781 )/r(sd))^2 
qui su inter14
gen inter14a=((.0441672 )/r(sd))^2 
qui su inter15
gen inter15a=((.133929 )/r(sd))^2 
qui su inter16
gen inter16a=((.0363273 )/r(sd))^2 
qui su inter17
gen inter17a=((.021152 )/r(sd))^2 
qui su inter18
gen inter18a=((.1019488 )/r(sd))^2 
qui su inter19
gen inter19a=((.1136377 )/r(sd))^2 
qui su inter20
gen inter20a=((.0108418 )/r(sd))^2 
qui su inter21
gen inter21a=((.0337012 )/r(sd))^2 

#delimit;
gen tstat=maina+inter1a+inter2a+inter3a+inter4a+inter5a+inter6a+inter7a+inter8a+inter9a+inter10a+
        inter11a+inter12a+inter13a+inter14a+inter15a+inter16a+inter17a+inter18a+inter19a+inter20a+
        inter21a;
#delimit cr

gsort -sum
keep sum tstat
save joint3,replace
