clear
set logtype t
set more off
set mem 48m
set matsize 800
cap log close

u c:\papers\arch\feb2002\vit4,clear
replace region=3 if region==.				/*Single missing*/
gen     reg=region if region>=1 & region<=4	/*NE,NC,S,W*/
replace reg=4 if region>=5 				/*Alaska, Hawaii allocated to West*/
tab reg,gen(regd)
replace marit=2 if marit==. /*Single missing observation*/
gen     mst=1 if marit==1|marit==8 & year==67
replace mst=2 if marit==2
replace mst=3 if marit==3
replace mst=4 if marit==4
replace mst=5 if marit==5
replace mst=6 if mst==.
drop marit
ren mst marit
gen married=marit==1
gen bigsmsa=smsa>=1 & smsa<=3
gen age2=age^2
tab year,gen(yrd)
keep newid year ly studio yrd* age age2 white regd* bigsmsa
save c:\papers\arch\feb2002\permboot,replace

u c:\papers\arch\feb2002\permboot,replace
keep if studio==1
save c:\papers\arch\feb2002\permboot1,replace
u c:\papers\arch\feb2002\permboot,replace
keep if studio==2
save c:\papers\arch\feb2002\permboot2,replace
u c:\papers\arch\feb2002\permboot,replace
keep if studio==3
save c:\papers\arch\feb2002\permboot3,replace





u c:\papers\arch\feb2002\permboot,clear
bsample, cluster(newid) id(idboot)
reg ly yrd* age age2 white regd1-regd4 bigsmsa
predict u,res
sort idboot year
qui by idboot: gen du=u-u[_n-1]
keep idboot year du
sort idboot year
fillin idboot year
gen ydu=du!=.
replace du=0 if du==.
egen maxy=max(year)
egen miny=min(year)
scalar nyears=maxy-miny+1
drop maxy miny
scalar nind=_N/nyears
sort idboot year
gen id=group(nind)
compress
keep id year du ydu
order id year du ydu

outfile using c:\papers\arch\jan2002\dta\edboot,replace
cd c:\gausswin
!atog c:\papers\arch\jan2002\do\edboot.cmd
erase c:\papers\arch\jan2002\dta\edboot.raw

cd c:\gausswin
!gauss c:\papers\arch\jan2002\do\tab3boot.prg
!exit
!gauss c:\papers\arch\jan2002\do\tab4boot.prg
!exit
!gauss c:\papers\arch\feb2002\p_boot_a.run
!exit


cap program drop doit
program def doit
         local i=1
         while `i' < 100 {
		u c:\papers\arch\feb2002\permboot,clear
		bsample, cluster(newid) id(idboot)
		reg ly yrd* age age2 white regd1-regd4 bigsmsa
		predict u,res
		sort idboot year
		qui by idboot: gen du=u-u[_n-1]
		keep idboot year du
		sort idboot year
		fillin idboot year
		gen ydu=du!=.
		replace du=0 if du==.
		egen maxy=max(year)
		egen miny=min(year)
		scalar nyears=maxy-miny+1
		drop maxy miny
		scalar nind=_N/nyears
		sort idboot year
		gen id=group(nind)
		compress
		keep id year du ydu
		order id year du ydu

		outfile using c:\papers\arch\jan2002\dta\edboot,replace
		cd c:\gausswin
		!atog c:\papers\arch\jan2002\do\edboot.cmd
		erase c:\papers\arch\jan2002\dta\edboot.raw

		cd c:\gausswin
		!gauss c:\papers\arch\jan2002\do\tab3boot.prg
		!exit
		!gauss c:\papers\arch\jan2002\do\tab4boot.prg
		!exit
		!gauss c:\papers\arch\feb2002\p_boot_b.run
		!exit
        local i=`i'+1
                }
end
qui doit

cd c:\papers\arch\feb2002
!ren p_boot.dat p_boot0.dat
!ren p_boot.dht p_boot0.dht


u c:\papers\arch\feb2002\permboot1,clear
bsample, cluster(newid) id(idboot)
reg ly yrd* age age2 white regd1-regd4 bigsmsa
predict u,res
sort idboot year
qui by idboot: gen du=u-u[_n-1]
keep idboot year du
sort idboot year
fillin idboot year
gen ydu=du!=.
replace du=0 if du==.
egen maxy=max(year)
egen miny=min(year)
scalar nyears=maxy-miny+1
drop maxy miny
scalar nind=_N/nyears
sort idboot year
gen id=group(nind)
compress
keep id year du ydu
order id year du ydu

outfile using c:\papers\arch\jan2002\dta\edboot,replace
cd c:\gausswin
!atog c:\papers\arch\jan2002\do\edboot.cmd
erase c:\papers\arch\jan2002\dta\edboot.raw

cd c:\gausswin
!gauss c:\papers\arch\jan2002\do\tab3boot.prg
!exit
!gauss c:\papers\arch\jan2002\do\tab4boot.prg
!exit
!gauss c:\papers\arch\feb2002\p_boot_a.run
!exit


cap program drop doit
program def doit
         local i=1
         while `i' < 100 {
		u c:\papers\arch\feb2002\permboot1,clear
		bsample, cluster(newid) id(idboot)
		reg ly yrd* age age2 white regd1-regd4 bigsmsa
		predict u,res
		sort idboot year
		qui by idboot: gen du=u-u[_n-1]
		keep idboot year du
		sort idboot year
		fillin idboot year
		gen ydu=du!=.
		replace du=0 if du==.
		egen maxy=max(year)
		egen miny=min(year)
		scalar nyears=maxy-miny+1
		drop maxy miny
		scalar nind=_N/nyears
		sort idboot year
		gen id=group(nind)
		compress
		keep id year du ydu
		order id year du ydu

		outfile using c:\papers\arch\jan2002\dta\edboot,replace
		cd c:\gausswin
		!atog c:\papers\arch\jan2002\do\edboot.cmd
		erase c:\papers\arch\jan2002\dta\edboot.raw

		cd c:\gausswin
		!gauss c:\papers\arch\jan2002\do\tab3boot.prg
		!exit
		!gauss c:\papers\arch\jan2002\do\tab4boot.prg
		!exit
		!gauss c:\papers\arch\feb2002\p_boot_b.run
		!exit
        local i=`i'+1
                }
end
qui doit

cd c:\papers\arch\feb2002
!ren p_boot.dat p_boot1.dat
!ren p_boot.dht p_boot1.dht


u c:\papers\arch\feb2002\permboot2,clear
bsample, cluster(newid) id(idboot)
reg ly yrd* age age2 white regd1-regd4 bigsmsa
predict u,res
sort idboot year
qui by idboot: gen du=u-u[_n-1]
keep idboot year du
sort idboot year
fillin idboot year
gen ydu=du!=.
replace du=0 if du==.
egen maxy=max(year)
egen miny=min(year)
scalar nyears=maxy-miny+1
drop maxy miny
scalar nind=_N/nyears
sort idboot year
gen id=group(nind)
compress
keep id year du ydu
order id year du ydu

outfile using c:\papers\arch\jan2002\dta\edboot,replace
cd c:\gausswin
!atog c:\papers\arch\jan2002\do\edboot.cmd
erase c:\papers\arch\jan2002\dta\edboot.raw

cd c:\gausswin
!gauss c:\papers\arch\jan2002\do\tab3boot.prg
!exit
!gauss c:\papers\arch\jan2002\do\tab4boot.prg
!exit
!gauss c:\papers\arch\feb2002\p_boot_a.run
!exit


cap program drop doit
program def doit
         local i=1
         while `i' < 100 {
		u c:\papers\arch\feb2002\permboot2,clear
		bsample, cluster(newid) id(idboot)
		reg ly yrd* age age2 white regd1-regd4 bigsmsa
		predict u,res
		sort idboot year
		qui by idboot: gen du=u-u[_n-1]
		keep idboot year du
		sort idboot year
		fillin idboot year
		gen ydu=du!=.
		replace du=0 if du==.
		egen maxy=max(year)
		egen miny=min(year)
		scalar nyears=maxy-miny+1
		drop maxy miny
		scalar nind=_N/nyears
		sort idboot year
		gen id=group(nind)
		compress
		keep id year du ydu
		order id year du ydu

		outfile using c:\papers\arch\jan2002\dta\edboot,replace
		cd c:\gausswin
		!atog c:\papers\arch\jan2002\do\edboot.cmd
		erase c:\papers\arch\jan2002\dta\edboot.raw

		cd c:\gausswin
		!gauss c:\papers\arch\jan2002\do\tab3boot.prg
		!exit
		!gauss c:\papers\arch\jan2002\do\tab4boot.prg
		!exit
		!gauss c:\papers\arch\feb2002\p_boot_b.run
		!exit
        local i=`i'+1
                }
end
qui doit

cd c:\papers\arch\feb2002
!ren p_boot.dat p_boot2.dat
!ren p_boot.dht p_boot2.dht


u c:\papers\arch\feb2002\permboot3,clear
bsample, cluster(newid) id(idboot)
reg ly yrd* age age2 white regd1-regd4 bigsmsa
predict u,res
sort idboot year
qui by idboot: gen du=u-u[_n-1]
keep idboot year du
sort idboot year
fillin idboot year
gen ydu=du!=.
replace du=0 if du==.
egen maxy=max(year)
egen miny=min(year)
scalar nyears=maxy-miny+1
drop maxy miny
scalar nind=_N/nyears
sort idboot year
gen id=group(nind)
compress
keep id year du ydu
order id year du ydu

outfile using c:\papers\arch\jan2002\dta\edboot,replace
cd c:\gausswin
!atog c:\papers\arch\jan2002\do\edboot.cmd
erase c:\papers\arch\jan2002\dta\edboot.raw

cd c:\gausswin
!gauss c:\papers\arch\jan2002\do\tab3boot.prg
!exit
!gauss c:\papers\arch\jan2002\do\tab4boot.prg
!exit
!gauss c:\papers\arch\feb2002\p_boot_a.run
!exit


cap program drop doit
program def doit
         local i=1
         while `i' < 100 {
		u c:\papers\arch\feb2002\permboot3,clear
		bsample, cluster(newid) id(idboot)
		reg ly yrd* age age2 white regd1-regd4 bigsmsa
		predict u,res
		sort idboot year
		qui by idboot: gen du=u-u[_n-1]
		keep idboot year du
		sort idboot year
		fillin idboot year
		gen ydu=du!=.
		replace du=0 if du==.
		egen maxy=max(year)
		egen miny=min(year)
		scalar nyears=maxy-miny+1
		drop maxy miny
		scalar nind=_N/nyears
		sort idboot year
		gen id=group(nind)
		compress
		keep id year du ydu
		order id year du ydu

		outfile using c:\papers\arch\jan2002\dta\edboot,replace
		cd c:\gausswin
		!atog c:\papers\arch\jan2002\do\edboot.cmd
		erase c:\papers\arch\jan2002\dta\edboot.raw

		cd c:\gausswin
		!gauss c:\papers\arch\jan2002\do\tab3boot.prg
		!exit
		!gauss c:\papers\arch\jan2002\do\tab4boot.prg
		!exit
		!gauss c:\papers\arch\feb2002\p_boot_b.run
		!exit
        local i=`i'+1
                }
end
qui doit

cd c:\papers\arch\feb2002
!ren p_boot.dat p_boot3.dat
!ren p_boot.dht p_boot3.dht


erase c:\papers\arch\feb2002\permboot.dta
erase c:\papers\arch\feb2002\permboot1.dta
erase c:\papers\arch\feb2002\permboot2.dta
erase c:\papers\arch\feb2002\permboot3.dta
