clear
set logtype t
set more off
set mem 48m
set matsize 800
cap log close
version 7

cd c:\papers\arch\feb2002
log using c:\papers\arch\feb2002\results,replace

*Graph of means and variances (Figures 1+2)

u vit4,clear
collapse (mean) m=ly (sd) s=ly,by(year)
gen studio=4
replace s=s^2
save whole,replace
u vit4,clear
collapse (mean) m=ly (sd) s=ly,by(studio year)
replace s=s^2
save studio,replace
u studio
append using whole
label define studio 1 "HS dropout" 2 "HS graduate" 3 "College graduate" 4 "Whole sample"
label values studio studio
lab var s "Variance log earnings"
lab var m "Mean log earnings"
lab var year "Year"
replace year=1900+year
ren studio Education
**********************Figure 1
graph m year,c(L) xla yla by(Education) saving(meanly,replace)
**********************Figure 2
graph s year,c(L) xla yla by(Education) saving(varly,replace)
erase whole.dta
erase studio.dta

u vit4,clear
**********************Table A1
tab year
sort newid year
qui by newid:drop if newid==newid[_n-1]

**********************Table A2
tab nobs
tab nobs if studio==1
tab nobs if studio==2
tab nobs if studio==3
clear

u vit4,clear
gen     mst=1 if marit==1|marit==8 & year==67
replace mst=2 if marit==2
replace mst=3 if marit==3
replace mst=4 if marit==4
replace mst=5 if marit==5
replace mst=6 if mst==.
drop marit
ren mst marit
gen married=marit==1
tab studio,gen(std)
gen y=totfy/price
replace region=3 if region==.				/*Single missing*/
gen     reg=region if region>=1 & region<=4	/*NE,NC,S,W*/
replace reg=4 if region>=5 				/*Alaska, Hawaii allocated to West*/
tab reg,gen(regd)
gen bigsmsa=smsa>=1 & smsa<=3

*************************Table A3
su age std1 std2 hour married white nchild fsize y regd1-regd3 bigsmsa if year==67
su age std1 std2 hour married white nchild fsize y regd1-regd3 bigsmsa if year==79
su age std1 std2 hour married white nchild fsize y regd1-regd3 bigsmsa if year==92
clear

*************************Footnote 7
u vit4,clear

replace region=3 if region==.				/*Single missing*/
gen     reg=region if region>=1 & region<=4	/*NE,NC,S,W*/
replace reg=4 if region>=5 				/*Alaska, Hawaii allocated to West*/
tab reg,gen(regd)

gen bigsmsa=smsa>=1 & smsa<=3

gen age2=age^2

tab year,gen(yrd)

cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen agelin`i'=age*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen agesq`i'=age2*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen blanc`i'=white*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen north`i'=regd1*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen south`i'=regd2*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen cente`i'=regd3*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen city`i'=bigsmsa*yrd`i'
        local i=`i'+1
                }
end
qui doit

qui reg ly  yrd1-yrd25 age agelin1-agelin25 age2 agesq1-agesq25 bigsmsa city1-city25 /*
	    */white blanc1-blanc25 regd1 north1-north25 regd2 south1-south25 regd3 cente1-cente25 if studio==1
qui testparm agelin*
cap program drop doit
program def doit
         local i=1
         while `i' < 25 {
		test agesq`i',acc
		test blanc`i',acc
		test north`i',acc
		test south`i',acc
		test cente`i',acc
		test city`i' ,acc
        local i=`i'+1
                }
end
qui doit

qui test agesq25,acc
qui test blanc25,acc
qui test north25,acc
qui test south25,acc
qui test cente25,acc
    test city25 ,acc

qui reg ly  yrd1-yrd25 age agelin1-agelin25 age2 agesq1-agesq25 bigsmsa city1-city25 /*
	    */white blanc1-blanc25 regd1 north1-north25 regd2 south1-south25 regd3 cente1-cente25 if studio==2
qui testparm agelin*
cap program drop doit
program def doit
         local i=1
         while `i' < 25 {
		test agesq`i',acc
		test blanc`i',acc
		test north`i',acc
		test south`i',acc
		test cente`i',acc
		test city`i' ,acc
        local i=`i'+1
                }
end
qui doit

qui test agesq25,acc
qui test blanc25,acc
qui test north25,acc
qui test south25,acc
qui test cente25,acc
    test city25 ,acc

qui reg ly  yrd1-yrd25 age agelin1-agelin25 age2 agesq1-agesq25 bigsmsa city1-city25 /*
	    */white blanc1-blanc25 regd1 north1-north25 regd2 south1-south25 regd3 cente1-cente25 if studio==3
qui testparm agelin*
cap program drop doit
program def doit
         local i=1
         while `i' < 25 {
		test agesq`i',acc
		test blanc`i',acc
		test north`i',acc
		test south`i',acc
		test cente`i',acc
		test city`i' ,acc
        local i=`i'+1
                }
end
qui doit

qui test agesq25,acc
qui test blanc25,acc
qui test north25,acc
qui test south25,acc
qui test cente25,acc
    test city25 ,acc

clear

**********The rest of Footnote 7 (arch results) is in the file results_last.do
* do results_last.do 
* results_last.do calls the files wgiv_tb.run and wgivpb.run

u vit4,clear

replace region=3 if region==.				/*Single missing*/
gen     reg=region if region>=1 & region<=4	/*NE,NC,S,W*/
replace reg=4 if region>=5 				/*Alaska, Hawaii allocated to West*/
tab reg,gen(regd)

replace marit=2 if marit==. /*Single missing observation*/
gen     mst=1 if marit==1|marit==8 & year==67
replace mst=2 if marit==2
replace mst=3 if marit==3
replace mst=4 if marit==4
replace mst=5 if marit==5
replace mst=6 if mst==.
drop marit
ren mst marit
gen married=marit==1

gen bigsmsa=smsa>=1 & smsa<=3

gen age2=age^2

tab year,gen(yrd)

******(REGRESSIONS MENTIONED ON PAGE 6, SECTION 3.1: to get shocks)
reg ly yrd* age age2 white regd1-regd4 bigsmsa if studio==1
predict u1 if studio==1,res
reg ly yrd* age age2 white regd1-regd4 bigsmsa if studio==2
predict u2 if studio==2,res
reg ly yrd* age age2 white regd1-regd4 bigsmsa if studio==3
predict u3 if studio==3,res

gen     u=u1 if studio==1
replace u=u2 if studio==2
replace u=u3 if studio==3
drop u1 u2 u3

sort newid year
qui by newid:gen du=u-u[_n-1]
keep newid year du studio
save edu,replace

cap program drop doit
program def doit
         local i=1
         while `i' < 4 {
		u edu,clear
		keep if studio==`i'
		keep newid year du
		save edu`i',replace
        local i=`i'+1
                }
end
qui doit


u c:\papers\arch\feb2002\edu,clear
gen dudu0=du^2
sort newid year
qui by newid:gen dudu1=du*du[_n-1]
qui by newid:gen dudu2=du*du[_n-2]
qui by newid:gen dudu3=du*du[_n-3]
qui by newid:gen dudu4=du*du[_n-4]


*****************Table I
reg dudu0,cluster(newid)
reg dudu1,cluster(newid)
reg dudu2,cluster(newid)
reg dudu3,cluster(newid)
reg dudu4,cluster(newid)
sort studio
by studio:reg dudu0,cluster(newid)
by studio:reg dudu1,cluster(newid)
by studio:reg dudu2,cluster(newid)
by studio:reg dudu3,cluster(newid)
by studio:reg dudu4,cluster(newid)

keep newid year du
sort newid year
fillin newid year
gen ydu=du!=.
replace du=0 if du==.
egen maxy=max(year)
egen miny=min(year)
scalar nyears=maxy-miny+1
drop maxy miny
scalar nind=_N/nyears
sort newid year
gen id=group(nind)
compress
keep id year du ydu
order id year du ydu
outfile using ed,replace
cd c:\gausswin
!atog c:\papers\arch\feb2002\ed.cmd
erase c:\papers\arch\feb2002\ed.raw

cd c:\papers\arch\feb2002


cap program drop doit
program def doit
         local i=1
         while `i' < 4 {
		u c:\papers\arch\feb2002\edu`i',clear
		sort newid year
		fillin newid year
		gen ydu=du!=.
		replace du=0 if du==.
		egen maxy=max(year)
		egen miny=min(year)
		scalar nyears=maxy-miny+1
		drop maxy miny
		scalar nind=_N/nyears
		sort newid year
		gen id=group(nind)
		compress
		keep id year du ydu
		order id year du ydu
		outfile using c:\papers\arch\feb2002\ed`i',replace
		cd c:\gausswin
		!atog c:\papers\arch\feb2002\ed`i'.cmd
		erase c:\papers\arch\feb2002\ed`i'.raw
        local i=`i'+1
                }
end
qui doit

clear
cd c:\papers\arch\feb2002

****Table II (Costas' part)
u c:\papers\arch\feb2002\edu,clear
sort newid year
qui by newid:gen dudu1=du*du[_n-1]
qui by newid:gen dudu2=du*du[_n-2]
qui by newid:gen dudu3=du*du[_n-3]
qui by newid:gen dudu4=du*du[_n-4]
tab year,gen(yrd)

cap program drop pv
program def pv
         local i=1
         while `i' < 2 {
		matrix test=e(b)*syminv(e(V))*e(b)'
		matrix b=e(b)
		matrix list test
		di colsof(b)
		di 1-chi2(colsof(b),test[1,1])
        local i=`i'+1
                }
end


qui reg dudu1 yrd3-yrd26, cluster(newid) nocons
pv
qui reg dudu1 yrd3-yrd26 if studio==1, cluster(newid) nocons
pv
qui reg dudu1 yrd3-yrd26 if studio==2, cluster(newid) nocons
pv
qui reg dudu1 yrd3-yrd26 if studio==3, cluster(newid) nocons
pv

qui reg dudu2 yrd4-yrd26, cluster(newid) nocons
pv
qui reg dudu2 yrd4-yrd26 if studio==1, cluster(newid) nocons
pv
qui reg dudu2 yrd4-yrd26 if studio==2, cluster(newid) nocons
pv
qui reg dudu2 yrd4-yrd26 if studio==3, cluster(newid) nocons
pv

qui reg dudu3 yrd5-yrd26, cluster(newid) nocons
pv
qui reg dudu3 yrd5-yrd26 if studio==1, cluster(newid) nocons
pv
qui reg dudu3 yrd5-yrd26 if studio==2, cluster(newid) nocons
pv
qui reg dudu3 yrd5-yrd26 if studio==3, cluster(newid) nocons
pv

qui reg dudu4 yrd6-yrd26, cluster(newid) nocons
pv
qui reg dudu4 yrd6-yrd26 if studio==1, cluster(newid) nocons
pv
qui reg dudu4 yrd6-yrd26 if studio==2, cluster(newid) nocons
pv
qui reg dudu4 yrd6-yrd26 if studio==3, cluster(newid) nocons
pv

clear

*Table II, zero restrictions of the Abowd-Card form, reported only for whole sample in footnote to table
cd c:\gausswin
!gauss c:\papers\arch\feb2002\table3_0.prg

*Generates education-specific moments (and variances) to be used in EWMD procedures later
!gauss c:\papers\arch\feb2002\table3_1.prg
!gauss c:\papers\arch\feb2002\table3_2.prg
!gauss c:\papers\arch\feb2002\table3_3.prg

*Table A4
!gauss c:\papers\arch\feb2002\taba3_0.prg
!exit
!gauss c:\papers\arch\feb2002\taba3_1.prg
!exit
!gauss c:\papers\arch\feb2002\taba3_2.prg
!exit
!gauss c:\papers\arch\feb2002\taba3_3.prg
!exit

*Table III, lower part ("Measurement error external estimate")
u c:\papers\arch\feb2002\vit4,clear
sort newid year
qby newid:gen g=ly-ly[_n-1]
su g,d
gen m0=(0.25*r(Var))/2
su g if studio==1,d
gen m1=(0.25*r(Var))/2
su g if studio==2,d
gen m2=(0.25*r(Var))/2
su g if studio==3,d
gen m3=(0.25*r(Var))/2
keep in 1
keep m0-m3
save c:\papers\arch\feb2002\meas_err,replace
stcmd c:\papers\arch\feb2002\meas_err.dta c:\papers\arch\feb2002\meas_err.dat /y
erase c:\papers\arch\feb2002\meas_err.dta

*Table III, lower part ("Using an external...")
!gauss c:\papers\arch\jan2002\do\table4_0.prg
!exit
!gauss c:\papers\arch\jan2002\do\table4_1.prg
!exit
!gauss c:\papers\arch\jan2002\do\table4_2.prg
!exit
!gauss c:\papers\arch\jan2002\do\table4_3.prg
!exit


*This computes bootstrap standard error for variance of permanent shock, last row Table III
*do c:\papers\arch\feb2002\permboot
*This file calss tab3boot.prg, tab4boot.prg, and p_boot_a.run

*Upper part of Table III ("Conditioning on the feasible range...")
*(Now it's set for college graduate, you have to change the values of
*covariances, etc., to get the numbers in the Table)
*c:\papers\arch\doc\boundsjan2002xls.prg

*Table A5
!gauss c:\papers\arch\feb2002\tablea4.prg
!exit


**************Table IV :check identifiability for trans and perm shock (first diffs & WG)
do c:\papers\arch\feb2002\results_tab4.do

cd c:\papers\arch\feb2002


*****************CREATES DATA SETS TO BE USED FOR BOOTSTRAP GMM ANALYSIS
u c:\papers\arch\feb2002\vit4,clear
replace region=3 if region==.				/*Single missing*/
gen     reg=region if region>=1 & region<=4	/*NE,NC,S,W*/
replace reg=4 if region>=5 				/*Alaska, Hawaii allocated to West*/
tab reg,gen(regd)

replace marit=2 if marit==. /*Single missing observation*/
gen     mst=1 if marit==1|marit==8 & year==67
replace mst=2 if marit==2
replace mst=3 if marit==3
replace mst=4 if marit==4
replace mst=5 if marit==5
replace mst=6 if mst==.
drop marit
ren mst marit
gen married=marit==1

gen bigsmsa=smsa>=1 & smsa<=3

gen age2=age^2

tab year,gen(yrd)
reg ly yrd1-yrd25 age age2 white regd1-regd3 bigsmsa if studio==1
predict u1 if studio==1,res
reg ly yrd1-yrd25 age age2 white regd1-regd3 bigsmsa if studio==2
predict u2 if studio==2,res
reg ly yrd1-yrd25 age age2 white regd1-regd3 bigsmsa if studio==3
predict u3 if studio==3,res

gen     u=u1 if studio==1
replace u=u2 if studio==2
replace u=u3 if studio==3
drop u1 u2 u3
save c:\papers\arch\feb2002\vit4xboot,replace



************* This does Footnote 21 (p-value test alternative specification)
* do c:\papers\arch\feb2002\archboot



cap program drop doit
program def doit
         local i=1
         while `i' < 4 {
		u c:\papers\arch\feb2002\vit4xboot,clear
		replace year=1900+year
		sort newid year
		ren studio edgr
		keep if edgr==`i'
		drop nobs
		gen n=1
		egen nobs=sum(n),by(newid)
		drop n
		egen agem=mean(age),by(newid)
		egen age2m=mean(age2),by(newid)
		replace agem=age-agem
		replace age2m=age2-age2m
		keep ly year newid agem age2m age age2 nobs u regd1 regd2 regd3 bigsmsa white
		tab year,gen(yrd)
		drop yrd26
		#delimit;
		order nobs newid year ly  agem age2m age age2 regd1 regd2 regd3 bigsmsa white 
			yrd1  yrd2  yrd3  yrd4  yrd5  yrd6  yrd7  yrd8  yrd9  yrd10 
			yrd11 yrd12 yrd13 yrd14 yrd15 yrd16 yrd17 yrd18 yrd19 yrd20
			yrd21 yrd22 yrd23 yrd24 yrd25 u;
		sort  nobs newid year ly  agem age2m age age2 regd1 regd2 regd3 bigsmsa white 
			yrd1  yrd2  yrd3  yrd4  yrd5  yrd6  yrd7  yrd8  yrd9  yrd10 
			yrd11 yrd12 yrd13 yrd14 yrd15 yrd16 yrd17 yrd18 yrd19 yrd20
			yrd21 yrd22 yrd23 yrd24 yrd25 u;
		#delimit cr
		save c:\papers\arch\feb2002\boot`i',replace
		outfile using c:\papers\arch\feb2002\boot`i',replace
		cd c:\gausswin
		!atog c:\papers\arch\feb2002\boot`i'.cmd
		erase c:\papers\arch\feb2002\boot`i'.raw
        local i=`i'+1
                }
end
qui doit

cap program drop doit
program def doit
	  local i=1
        while `i' < 4 {
        u c:\papers\arch\feb2002\boot`i',clear
	  drop nobs	
        gen n=1
        egen nobs=sum(n),by(newid)
        sort newid year
        drop if newid==newid[_n-1]
        gen x=1
        egen nind=sum(x),by(nobs)
        collapse nind,by(nobs)
        sort nobs nind
        save c:\papers\arch\feb2002\boot`i'aux,replace old
	  outfile using c:\papers\arch\feb2002\boot`i'aux,replace
	  cd c:\gausswin
	  !atog c:\papers\arch\feb2002\boot`i'aux.cmd
	  erase c:\papers\arch\feb2002\boot`i'aux.raw
        local i=`i'+1
                }
end
qui doit

*****************Run BOOTSTRAP GMM
cd c:\gausswin
*****************Transitory shock
!gauss c:\papers\arch\feb2002\boot_t1.run
!exit
!ren bootres.dat boot_t1.dat
!ren bootres.dht boot_t1.dht
!gauss c:\papers\arch\feb2002\boot_t2.run
!exit
!ren bootres.dat boot_t2.dat
!ren bootres.dht boot_t2.dht
!gauss c:\papers\arch\feb2002\boot_t3.run
!exit
!ren bootres.dat boot_t3.dat
!ren bootres.dht boot_t3.dht
*****************Permanent shock
!gauss c:\papers\arch\feb2002\boot_p1.run
!exit
!ren bootres.dat boot_p1.dat
!ren bootres.dht boot_p1.dht
!gauss c:\papers\arch\feb2002\boot_p2.run
!exit
!ren bootres.dat boot_p2.dat
!ren bootres.dht boot_p2.dht
!gauss c:\papers\arch\feb2002\boot_p3.run
!exit
!ren bootres.dat boot_p3.dat
!ren bootres.dht boot_p3.dht

*****************Run BOOTSTRAP GMM FOR THE COLLEGE GRADUATE, q=0 case (footnote 12, reported on page 19)
!gauss c:\papers\arch\feb2002\boot_p3X.run
!exit
!ren bootres.dat boot_p3X.dat
!ren bootres.dht boot_p3X.dht


******For p-values time+age/time
do c:\papers\arch\feb2002\test_joint.do



cap program drop doit
program def doit
	  local i=1
        while `i' < 4 {
		u c:\papers\arch\feb2002\datares,clear
		replace year=1900+year
		egen pm=mean(p),by(newid)
		egen tm=mean(t),by(newid)
		egen agem=mean(age),by(newid)
		egen age2m=mean(age2),by(newid)
		gen devp=p-pm
		gen devt=t-tm
		gen devage=age-agem
		gen devage2=age2-age2m
		sort newid year
		keep if studio==`i'
		keep year newid t devt devage devage2 studio age age2
		keep if t!=.
		gen n=1
		egen nn=sum(n),by(newid)
		sort nn newid year
		drop n nn
		keep  newid year devt devage devage2 t studio age age2
		order newid year devt devage devage2 t studio age age2
		save c:\papers\arch\feb2002\wgiv`i',replace
		outfile using c:\papers\arch\feb2002\wgiv`i',replace
		cd c:\gausswin
		!atog c:\papers\arch\feb2002\wgiv`i'.cmd
		erase c:\papers\arch\feb2002\wgiv`i'.raw
        local i=`i'+1
                }
end
qui doit

cap program drop doit
program def doit
	  local i=1
        while `i' < 4 {
        u c:\papers\arch\feb2002\wgiv`i',clear
        gen n=1
        egen nobs=sum(n),by(newid)
        sort newid year
        drop if newid==newid[_n-1]
        gen x=1
        egen nind=sum(x),by(nobs)
        collapse nind,by(nobs)
        sort nobs nind
        save c:\papers\arch\feb2002\wg`i'aux,replace old
	  outfile using c:\papers\arch\feb2002\wg`i'aux,replace
	  cd c:\gausswin
	  !atog c:\papers\arch\feb2002\wg`i'aux.cmd
	  erase c:\papers\arch\feb2002\wg`i'aux.raw
        local i=`i'+1
                }
end
qui doit

cd c:\gausswin
!gauss c:\papers\arch\feb2002\wgiv1_tl.run
!exit
!gauss c:\papers\arch\feb2002\wgiv1_t.run
!exit
cd c:\gausswin
!gauss c:\papers\arch\feb2002\wgiv2_tl.run
!exit
!gauss c:\papers\arch\feb2002\wgiv2_t.run
!exit
cd c:\gausswin
!gauss c:\papers\arch\feb2002\wgiv3_tl.run
!exit
!gauss c:\papers\arch\feb2002\wgiv3_t.run
!exit

cap program drop doit
program def doit
	  local i=1
        while `i' < 4 {
		u c:\papers\arch\feb2002\datares,clear
		replace year=1900+year
		egen pm=mean(p),by(newid)
		egen tm=mean(t),by(newid)
		egen agem=mean(age),by(newid)
		egen age2m=mean(age2),by(newid)
		gen devp=p-pm
		gen devt=t-tm
		gen devage=age-agem
		gen devage2=age2-age2m
		sort newid year
		keep if studio==`i'
		keep year newid p devp devage devage2 studio age age2
		keep if p!=.
		gen n=1
		egen nn=sum(n),by(newid)
		sort nn newid year
		drop n nn
		keep  newid year devp devage devage2 p studio age age2
		order newid year devp devage devage2 p studio age age2
		save c:\papers\arch\feb2002\wgiv`i',replace
		outfile using c:\papers\arch\feb2002\wgiv`i',replace
		cd c:\gausswin
		!atog c:\papers\arch\feb2002\wgiv`i'.cmd
		erase c:\papers\arch\feb2002\wgiv`i'.raw
        local i=`i'+1
                }
end
qui doit


cap program drop doit
program def doit
	  local i=1
        while `i' < 4 {
        u c:\papers\arch\feb2002\wgiv`i',clear
        gen n=1
        egen nobs=sum(n),by(newid)
        sort newid year
        drop if newid==newid[_n-1]
        gen x=1
        egen nind=sum(x),by(nobs)
        collapse nind,by(nobs)
        sort nobs nind
        save c:\papers\arch\feb2002\wg`i'aux,replace old
	  outfile using c:\papers\arch\feb2002\wg`i'aux,replace
	  cd c:\gausswin
	  !atog c:\papers\arch\feb2002\wg`i'aux.cmd
	  erase c:\papers\arch\feb2002\wg`i'aux.raw
        local i=`i'+1
                }
end
qui doit

cd c:\gausswin
!gauss c:\papers\arch\feb2002\wgiv1_pl.run
!exit
!gauss c:\papers\arch\feb2002\wgiv1_p.run
!exit
cd c:\gausswin
!gauss c:\papers\arch\feb2002\wgiv2_pl.run
!exit
!gauss c:\papers\arch\feb2002\wgiv2_p.run
!exit
cd c:\gausswin
!gauss c:\papers\arch\feb2002\wgiv3_pl.run
!exit
!gauss c:\papers\arch\feb2002\wgiv3_p.run
!exit

cd c:\gausswin
!gauss c:\papers\arch\feb2002\wg3_plX.run
!exit
!gauss c:\papers\arch\feb2002\wgiv3_pX.run
!exit




log close
clear
