clear
set logtype t
set more off
set mem 70m
set matsize 800
cap log close

cd c:\papers\arch\feb2002
log using c:\papers\arch\feb2002\results_last,replace


*************************Footnote 7
u vit4,clear

replace region=3 if region==.				/*Single missing*/
gen     reg=region if region>=1 & region<=4	/*NE,NC,S,W*/
replace reg=4 if region>=5 				/*Alaska, Hawaii allocated to West*/
tab reg,gen(regd)

gen bigsmsa=smsa>=1 & smsa<=3
gen age2=age^2
tab year,gen(yrd)

cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen agelin`i'=age*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen agesq`i'=age2*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen blanc`i'=white*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen north`i'=regd1*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen south`i'=regd2*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen cente`i'=regd3*yrd`i'
        local i=`i'+1
                }
end
qui doit
cap program drop doit
program def doit
         local i=1
         while `i' < 27 {
		gen city`i'=bigsmsa*yrd`i'
        local i=`i'+1
                }
end
qui doit

*****REST OF FOOTNOTE 7: CHECK ARCH NUMBERS WITH THIS EARNINGS SPECIFICATION
*****ONLY FOR HIGH SCHOOL GRADUATE GROUP
keep if studio==2
qui reg ly  yrd1-yrd25 age agelin1-agelin25 age2 agesq1-agesq25 bigsmsa city1-city25 /*
	    */white blanc1-blanc25 regd1 north1-north25 regd2 south1-south25 regd3 cente1-cente25
predict u,res

sort newid year
qui by newid:gen g=u-u[_n-1]
qui by newid:gen p=(g^2)+(g*g[_n-1])+(g*g[_n-2])+(g*g[_n+1])+(g*g[_n+2]) 
qui by newid:gen t=g*g[_n+2]

keep newid year age age2 t p ly studio
sort newid year
save dataresbis,replace

*****TRANSITORY SHOCK CASE
replace year=1900+year
egen pm=mean(p),by(newid)
egen tm=mean(t),by(newid)
egen agem=mean(age),by(newid)
egen age2m=mean(age2),by(newid)
gen devp=p-pm
gen devt=t-tm
gen devage=age-agem
gen devage2=age2-age2m
sort newid year
keep year newid t devt devage devage2 studio age age2
keep if t!=.
gen n=1
egen nn=sum(n),by(newid)
sort nn newid year
drop n nn
keep  newid year devt devage devage2 t studio age age2
order newid year devt devage devage2 t studio age age2
save c:\papers\arch\feb2002\wgiv2bis,replace
outfile using c:\papers\arch\feb2002\wgiv2bis,replace
cd c:\gausswin
!atog c:\papers\arch\feb2002\wgiv2bis.cmd
erase c:\papers\arch\feb2002\wgiv2bis.raw

u c:\papers\arch\feb2002\wgiv2bis,clear
gen n=1
egen nobs=sum(n),by(newid)
sort newid year
drop if newid==newid[_n-1]
gen x=1
egen nind=sum(x),by(nobs)
collapse nind,by(nobs)
sort nobs nind
save c:\papers\arch\feb2002\wg2auxbi,replace old
outfile using c:\papers\arch\feb2002\wg2auxbi,replace
cd c:\gausswin
!atog c:\papers\arch\feb2002\wg2auxbi.cmd
erase c:\papers\arch\feb2002\wg2auxbi.raw

cd c:\gausswin
!gauss c:\papers\arch\feb2002\wgiv2_tb.run
!exit

*****PERMANENT SHOCK CASE
u c:\papers\arch\feb2002\dataresbis,clear
replace year=1900+year
egen pm=mean(p),by(newid)
egen tm=mean(t),by(newid)
egen agem=mean(age),by(newid)
egen age2m=mean(age2),by(newid)
gen devp=p-pm
gen devt=t-tm
gen devage=age-agem
gen devage2=age2-age2m
sort newid year
keep year newid p devp devage devage2 studio age age2
keep if p!=.
gen n=1
egen nn=sum(n),by(newid)
sort nn newid year
drop n nn
keep  newid year devp devage devage2 p studio age age2
order newid year devp devage devage2 p studio age age2
save c:\papers\arch\feb2002\wgiv2bis,replace
outfile using c:\papers\arch\feb2002\wgiv2bis,replace
cd c:\gausswin
!atog c:\papers\arch\feb2002\wgiv2bis.cmd
erase c:\papers\arch\feb2002\wgiv2bis.raw

u c:\papers\arch\feb2002\wgiv2bis,clear
gen n=1
egen nobs=sum(n),by(newid)
sort newid year
drop if newid==newid[_n-1]
gen x=1
egen nind=sum(x),by(nobs)
collapse nind,by(nobs)
sort nobs nind
save c:\papers\arch\feb2002\wg2auxbi,replace old
outfile using c:\papers\arch\feb2002\wg2auxbi,replace
cd c:\gausswin
!atog c:\papers\arch\feb2002\wg2auxbi.cmd
erase c:\papers\arch\feb2002\wg2auxbi.raw

cd c:\gausswin
!gauss c:\papers\arch\feb2002\wgiv2_pb.run
!exit

log close
clear
