clear
set logtype t
set more off
set mem 48m
set matsize 800
cap log close

cd c:\papers\arch\feb2002
u vit4,clear
replace region=3 if region==.				/*Single missing*/
gen     reg=region if region>=1 & region<=4	/*NE,NC,S,W*/
replace reg=4 if region>=5 				/*Alaska, Hawaii allocated to West*/
tab reg,gen(regd)
gen bigsmsa=smsa>=1 & smsa<=3
gen age2=age^2
tab year,gen(yrd)
reg ly yrd* age age2 white regd1-regd4 bigsmsa if studio==1
predict u1 if studio==1,res
reg ly yrd* age age2 white regd1-regd4 bigsmsa if studio==2
predict u2 if studio==2,res
reg ly yrd* age age2 white regd1-regd4 bigsmsa if studio==3
predict u3 if studio==3,res
gen     u=u1 if studio==1
replace u=u2 if studio==2
replace u=u3 if studio==3
drop u1 u2 u3
sort newid year
qui by newid:gen g=u-u[_n-1]
sort newid year
qui by newid:gen p=(g^2)+(g*g[_n-1])+(g*g[_n-2])+(g*g[_n+1])+(g*g[_n+2]) 
qui by newid:gen t=g*g[_n+2]
egen pm=mean(p),by(newid)
egen tm=mean(t),by(newid)
egen agem=mean(age),by(newid)
egen age2m=mean(age2),by(newid)
gen devp=p-pm
gen devt=t-tm
gen devage=age-agem
gen devage2=age2-age2m
sort newid year
qui by newid:gen dt   =(t)-(t[_n-1])
qui by newid:gen t4   =(t[_n-4])
qui by newid:gen t5   =(t[_n-5])
qui by newid:gen dp   =(p)-(p[_n-1])
qui by newid:gen p6   =(p[_n-6])
qui by newid:gen p7   =(p[_n-7])
qui by newid:gen devp1=devp[_n-1]
qui by newid:gen devt1=devt[_n-1]

reg dt    t4 t5 yrd* age age2 
matrix b=e(b)'
matrix V=e(V)
matrix chitfd=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg devt1 t4 t5 yrd* devage devage2
matrix b=e(b)'
matrix V=e(V)
matrix chitwg=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg dp    p6 p7 yrd* age age2
matrix b=e(b)'
matrix V=e(V)
matrix chipfd=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg devp1 p6 p7 yrd* devage devage2
matrix b=e(b)'
matrix V=e(V)
matrix chipwg=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
matrix list chitfd
matrix list chitwg
matrix list chipfd
matrix list chipwg

reg dt    t4 t5 yrd* age age2 if studio==1
matrix b=e(b)'
matrix V=e(V)
matrix chitfd=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg devt1 t4 t5 yrd* devage devage2 if studio==1
matrix b=e(b)'
matrix V=e(V)
matrix chitwg=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg dp    p6 p7 yrd* age age2 if studio==1
matrix b=e(b)'
matrix V=e(V)
matrix chipfd=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg devp1 p6 p7 yrd* devage devage2 if studio==1
matrix b=e(b)'
matrix V=e(V)
matrix chipwg=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
matrix list chitfd
matrix list chitwg
matrix list chipfd
matrix list chipwg

reg dt    t4 t5 yrd* age age2 if studio==2
matrix b=e(b)'
matrix V=e(V)
matrix chitfd=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg devt1 t4 t5 yrd* devage devage2 if studio==2
matrix b=e(b)'
matrix V=e(V)
matrix chitwg=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg dp    p6 p7 yrd* age age2 if studio==2
matrix b=e(b)'
matrix V=e(V)
matrix chipfd=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg devp1 p6 p7 yrd* devage devage2 if studio==2
matrix b=e(b)'
matrix V=e(V)
matrix chipwg=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
matrix list chitfd
matrix list chitwg
matrix list chipfd
matrix list chipwg

reg dt    t4 t5 yrd* age age2 if studio==3
matrix b=e(b)'
matrix V=e(V)
matrix chitfd=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg devt1 t4 t5 yrd* devage devage2 if studio==3
matrix b=e(b)'
matrix V=e(V)
matrix chitwg=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg dp    p6 p7 yrd* age age2 if studio==3
matrix b=e(b)'
matrix V=e(V)
matrix chipfd=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
reg devp1 p6 p7 yrd* devage devage2 if studio==3
matrix b=e(b)'
matrix V=e(V)
matrix chipwg=b[1..2,1]'*syminv(V[1..2,1..2])*b[1..2,1]
matrix list chitfd
matrix list chitwg
matrix list chipfd
matrix list chipwg

clear
log close



cd c:\papers\arch\feb2002
u vit4,clear
replace region=3 if region==.				/*Single missing*/
gen     reg=region if region>=1 & region<=4	/*NE,NC,S,W*/
replace reg=4 if region>=5 				/*Alaska, Hawaii allocated to West*/
tab reg,gen(regd)
replace marit=2 if marit==. /*Single missing observation*/
gen     mst=1 if marit==1|marit==8 & year==67
replace mst=2 if marit==2
replace mst=3 if marit==3
replace mst=4 if marit==4
replace mst=5 if marit==5
replace mst=6 if mst==.
drop marit
ren mst marit
gen married=marit==1
gen bigsmsa=smsa>=1 & smsa<=3
gen age2=age^2
tab year,gen(yrd)
keep newid year ly yrd* age age2 white regd1-regd4 bigsmsa studio
save temp,replace

capture program drop tab4_boot
    program define tab4_boot
            version 7.0
            if "`1'" == "?"   {
                    global S_1 "tran1fd tran2fd perm1fd perm2fd tran1wg tran2wg perm1wg perm2wg"
                    exit
			            }
			qui reg ly yrd* age age2 white regd1-regd4 bigsmsa if studio==1
			predict u1 if studio==1,res
			qui reg ly yrd* age age2 white regd1-regd4 bigsmsa if studio==2
			predict u2 if studio==2,res
			qui reg ly yrd* age age2 white regd1-regd4 bigsmsa if studio==3
			predict u3 if studio==3,res

			gen     u=u1 if studio==1
			replace u=u2 if studio==2
			replace u=u3 if studio==3
			drop u1 u2 u3
			
			sort idboot year
			qui by idboot:gen g=u-u[_n-1]
			qui by idboot:gen p=(g^2)+(g*g[_n-1])+(g*g[_n-2])+(g*g[_n+1])+(g*g[_n+2]) 
			qui by idboot:gen t=g*g[_n+2]
			qui by idboot:gen dt     =(t)-(t[_n-1])
			qui by idboot:gen dt1    =(dt[_n-1])
			qui by idboot:gen t4     =(t[_n-4])
			qui by idboot:gen t5     =(t[_n-5])
			qui by idboot:gen t6     =(t[_n-6])
			qui by idboot:gen dp   =(p)      -(p[_n-1])
			qui by idboot:gen dp1  =(p[_n-1])-(p[_n-2])
			qui by idboot:gen p6   =(p[_n-6])
			qui by idboot:gen p7   =(p[_n-7])
			qui by idboot:gen p8   =(p[_n-8])

			reg dt   t4 t5 age age2 yrd*
			local TRAN1FD  = _b[t4]
			local TRAN2FD  = _b[t5]
			reg dp   p6 p7 age age2 yrd* 
			local PERM1FD  = _b[p6]
			local PERM2FD  = _b[p7]

			egen pm=mean(p),by(idboot)
			egen tm=mean(t),by(idboot)
			egen agem=mean(age),by(idboot)
			egen age2m=mean(age2),by(idboot)
			gen devp=p-pm
			gen devt=t-tm
			gen devage=age-agem
			gen devage2=age2-age2m
			sort idboot year
			qui by id:gen devp1=devp[_n-1]
			qui by idboot:gen devt1=devt[_n-1]

			reg devt1 t4 t5 yrd* devage devage2
			local TRAN1WG  = _b[t4]
			local TRAN2WG  = _b[t5]
			reg devp1 p6 p7 yrd* devage devage2
			local PERM1WG  = _b[p6]
			local PERM2WG  = _b[p7]
			post `1' (`TRAN1FD') (`TRAN2FD') (`PERM1FD') (`PERM2FD') (`TRAN1WG') (`TRAN2WG') (`PERM1WG') (`PERM2WG')
end

use temp, clear
set seed 104561
bstrap tab4_boot, reps(300) cluster(newid) idcluster(idboot) dots saving(tab4_boot0) replace every(5)
clear

u tab4_boot0,clear
scalar def bt4fd=-.0257103
scalar def bt5fd=.0380797
scalar def bp6fd=-.0151262
scalar def bp7fd=.0095567
scalar def bt4wg=-.0630412
scalar def bt5wg=-.0937567
scalar def bp6wg=-.1266253
scalar def bp7wg=-.1320924
replace tran1fd=tran1fd-bt4fd
replace tran2fd=tran2fd-bt5fd
replace perm1fd=perm1fd-bp6fd
replace perm2fd=perm2fd-bp7fd
replace tran1wg=tran1wg-bt4wg
replace tran2wg=tran2wg-bt5wg
replace perm1wg=perm1wg-bp6wg
replace perm2wg=perm2wg-bp7wg

correlate tran1fd tran2fd,c
matrix SIGMAtfd=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate tran1wg tran2wg,c
matrix SIGMAtwg=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate perm1fd perm2fd,c
matrix SIGMApfd=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate perm1wg perm2wg,c
matrix SIGMApwg=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))

mkmat tran1fd tran2fd,matrix(betatfd)
mkmat tran1wg tran2wg,matrix(betatwg)
mkmat perm1fd perm2fd,matrix(betapfd)
mkmat perm1wg perm2wg,matrix(betapwg)

gen temp=0
mkmat temp,matrix(chitfd)
mkmat temp,matrix(chitwg)
mkmat temp,matrix(chipfd)
mkmat temp,matrix(chipwg)
drop temp

cap program drop doit
program def doit
         local i=1
         while `i' < 301 {
		matrix beta=betatfd[`i',1..2]
		matrix chitfd[`i',1]=beta*syminv(SIGMAtfd)*beta'
		matrix beta=betatwg[`i',1..2]
		matrix chitwg[`i',1]=beta*syminv(SIGMAtwg)*beta'
		matrix beta=betapfd[`i',1..2]
		matrix chipfd[`i',1]=beta*syminv(SIGMApfd)*beta'
		matrix beta=betapwg[`i',1..2]
		matrix chipwg[`i',1]=beta*syminv(SIGMApwg)*beta'
        local i=`i'+1
                }
end
qui doit

svmat chitfd
svmat chitwg
svmat chipfd
svmat chipwg

count if chitfd>18.836929
di r(N)/300
count if chitwg>245.52347
di r(N)/300
count if chipfd>2.5696149
di r(N)/300
count if chipwg>360.7256
di r(N)/300

save,replace



capture program drop tab4_boot2
    program define tab4_boot2
            version 7.0
            if "`1'" == "?"   {
                    global S_1 "tran1fd tran2fd perm1fd perm2fd tran1wg tran2wg perm1wg perm2wg"
                    exit
			            }
			qui reg ly yrd* age age2 white regd1-regd4 bigsmsa
			predict u
			
			sort idboot year
			qui by idboot:gen g=u-u[_n-1]
			qui by idboot:gen p=(g^2)+(g*g[_n-1])+(g*g[_n-2])+(g*g[_n+1])+(g*g[_n+2]) 
			qui by idboot:gen t=g*g[_n+2]
			qui by idboot:gen dt     =(t)-(t[_n-1])
			qui by idboot:gen dt1    =(dt[_n-1])
			qui by idboot:gen t4     =(t[_n-4])
			qui by idboot:gen t5     =(t[_n-5])
			qui by idboot:gen t6     =(t[_n-6])
			qui by idboot:gen dp   =(p)      -(p[_n-1])
			qui by idboot:gen dp1  =(p[_n-1])-(p[_n-2])
			qui by idboot:gen p6   =(p[_n-6])
			qui by idboot:gen p7   =(p[_n-7])
			qui by idboot:gen p8   =(p[_n-8])

			reg dt   t4 t5 age age2 yrd*
			local TRAN1FD  = _b[t4]
			local TRAN2FD  = _b[t5]
			reg dp   p6 p7 age age2 yrd* 
			local PERM1FD  = _b[p6]
			local PERM2FD  = _b[p7]

			egen pm=mean(p),by(idboot)
			egen tm=mean(t),by(idboot)
			egen agem=mean(age),by(idboot)
			egen age2m=mean(age2),by(idboot)
			gen devp=p-pm
			gen devt=t-tm
			gen devage=age-agem
			gen devage2=age2-age2m
			sort idboot year
			qui by id:gen devp1=devp[_n-1]
			qui by idboot:gen devt1=devt[_n-1]

			reg devt1 t4 t5 yrd* devage devage2
			local TRAN1WG  = _b[t4]
			local TRAN2WG  = _b[t5]
			reg devp1 p6 p7 yrd* devage devage2
			local PERM1WG  = _b[p6]
			local PERM2WG  = _b[p7]
			post `1' (`TRAN1FD') (`TRAN2FD') (`PERM1FD') (`PERM2FD') (`TRAN1WG') (`TRAN2WG') (`PERM1WG') (`PERM2WG')
end

use temp, clear
keep if studio==1
set seed 104561
bstrap tab4_boot2, reps(300) cluster(newid) idcluster(idboot) dots saving(tab4_boot1) replace every(5)
clear

u tab4_boot1,clear
scalar def bt4_1fd=-.088028
scalar def bt5_1fd=.0471518
scalar def bp6_1fd=-.0234107
scalar def bp7_1fd=.0038657
scalar def bt4_1wg=-.0260495
scalar def bt5_1wg=-.1038438
scalar def bp6_1wg=-.1155016
scalar def bp7_1wg=-.1298803
replace tran1fd=tran1fd-bt4_1fd
replace tran2fd=tran2fd-bt5_1fd
replace perm1fd=perm1fd-bp6_1fd
replace perm2fd=perm2fd-bp7_1fd
replace tran1wg=tran1wg-bt4_1wg
replace tran2wg=tran2wg-bt5_1wg
replace perm1wg=perm1wg-bp6_1wg
replace perm2wg=perm2wg-bp7_1wg

correlate tran1fd tran2fd,c
matrix SIGMAtfd=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate tran1wg tran2wg,c
matrix SIGMAtwg=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate perm1fd perm2fd,c
matrix SIGMApfd=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate perm1wg perm2wg,c
matrix SIGMApwg=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))

mkmat tran1fd tran2fd,matrix(betatfd)
mkmat tran1wg tran2wg,matrix(betatwg)
mkmat perm1fd perm2fd,matrix(betapfd)
mkmat perm1wg perm2wg,matrix(betapwg)

gen temp=0
mkmat temp,matrix(chitfd)
mkmat temp,matrix(chitwg)
mkmat temp,matrix(chipfd)
mkmat temp,matrix(chipwg)
drop temp

cap program drop doit
program def doit
         local i=1
         while `i' < 301 {
		matrix beta=betatfd[`i',1..2]
		matrix chitfd[`i',1]=beta*syminv(SIGMAtfd)*beta'
		matrix beta=betatwg[`i',1..2]
		matrix chitwg[`i',1]=beta*syminv(SIGMAtwg)*beta'
		matrix beta=betapfd[`i',1..2]
		matrix chipfd[`i',1]=beta*syminv(SIGMApfd)*beta'
		matrix beta=betapwg[`i',1..2]
		matrix chipwg[`i',1]=beta*syminv(SIGMApwg)*beta'
        local i=`i'+1
                }
end
qui doit

svmat chitfd
svmat chitwg
svmat chipfd
svmat chipwg

count if chitfd>17.400449
di r(N)/300
count if chitwg>42.830562
di r(N)/300
count if chipfd>1.0965105
di r(N)/300
count if chipwg>65.30658
di r(N)/300

save,replace


use temp, clear
keep if studio==2
set seed 104561
bstrap tab4_boot2, reps(300) cluster(newid) idcluster(idboot) dots saving(tab4_boot2) replace every(5)
clear

u tab4_boot2,clear
scalar def bt4_2fd=.0555559
scalar def bt5_2fd=.0330423
scalar def bp6_2fd=.0067548
scalar def bp7_2fd=.0011634
scalar def bt4_2wg=-.1151395
scalar def bt5_2wg=-.085197
scalar def bp6_2wg=-.1596414
scalar def bp7_2wg=-.1329493
replace tran1fd=tran1fd-bt4_2fd
replace tran2fd=tran2fd-bt5_2fd
replace perm1fd=perm1fd-bp6_2fd
replace perm2fd=perm2fd-bp7_2fd
replace tran1wg=tran1wg-bt4_2wg
replace tran2wg=tran2wg-bt5_2wg
replace perm1wg=perm1wg-bp6_2wg
replace perm2wg=perm2wg-bp7_2wg

correlate tran1fd tran2fd,c
matrix SIGMAtfd=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate tran1wg tran2wg,c
matrix SIGMAtwg=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate perm1fd perm2fd,c
matrix SIGMApfd=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate perm1wg perm2wg,c
matrix SIGMApwg=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))

mkmat tran1fd tran2fd,matrix(betatfd)
mkmat tran1wg tran2wg,matrix(betatwg)
mkmat perm1fd perm2fd,matrix(betapfd)
mkmat perm1wg perm2wg,matrix(betapwg)

gen temp=0
mkmat temp,matrix(chitfd)
mkmat temp,matrix(chitwg)
mkmat temp,matrix(chipfd)
mkmat temp,matrix(chipwg)
drop temp

cap program drop doit
program def doit
         local i=1
         while `i' < 301 {
		matrix beta=betatfd[`i',1..2]
		matrix chitfd[`i',1]=beta*syminv(SIGMAtfd)*beta'
		matrix beta=betatwg[`i',1..2]
		matrix chitwg[`i',1]=beta*syminv(SIGMAtwg)*beta'
		matrix beta=betapfd[`i',1..2]
		matrix chipfd[`i',1]=beta*syminv(SIGMApfd)*beta'
		matrix beta=betapwg[`i',1..2]
		matrix chipwg[`i',1]=beta*syminv(SIGMApwg)*beta'
        local i=`i'+1
                }
end
qui doit

svmat chitfd
svmat chitwg
svmat chipfd
svmat chipwg

count if chitfd>26.564967
di r(N)/300
count if chitwg>267.87707
di r(N)/300
count if chipfd>0.09666193
di r(N)/300
count if chipwg>289.2582
di r(N)/300

save,replace


use temp, clear
keep if studio==3
set seed 104561
bstrap tab4_boot2, reps(300) cluster(newid) idcluster(idboot) dots saving(tab4_boot3) replace every(5)
clear

u tab4_boot3,clear
scalar def bt4_3fd=.0089256
scalar def bt5_3fd=.0177127
scalar def bp6_3fd=-.0249124
scalar def bp7_3fd=.0435156
scalar def bt4_3wg=-.0876356
scalar def bt5_3wg=-.0735052
scalar def bp6_3wg=-.0902948
scalar def bp7_3wg=-.1101366
replace tran1fd=tran1fd-bt4_3fd
replace tran2fd=tran2fd-bt5_3fd
replace perm1fd=perm1fd-bp6_3fd
replace perm2fd=perm2fd-bp7_3fd
replace tran1wg=tran1wg-bt4_3wg
replace tran2wg=tran2wg-bt5_3wg
replace perm1wg=perm1wg-bp6_3wg
replace perm2wg=perm2wg-bp7_3wg

correlate tran1fd tran2fd,c
matrix SIGMAtfd=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate tran1wg tran2wg,c
matrix SIGMAtwg=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate perm1fd perm2fd,c
matrix SIGMApfd=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))
correlate perm1wg perm2wg,c
matrix SIGMApwg=(r(Var_1),r(cov_12)\r(cov_12),r(Var_2))

mkmat tran1fd tran2fd,matrix(betatfd)
mkmat tran1wg tran2wg,matrix(betatwg)
mkmat perm1fd perm2fd,matrix(betapfd)
mkmat perm1wg perm2wg,matrix(betapwg)

gen temp=0
mkmat temp,matrix(chitfd)
mkmat temp,matrix(chitwg)
mkmat temp,matrix(chipfd)
mkmat temp,matrix(chipwg)
drop temp

cap program drop doit
program def doit
         local i=1
         while `i' < 301 {
		matrix beta=betatfd[`i',1..2]
		matrix chitfd[`i',1]=beta*syminv(SIGMAtfd)*beta'
		matrix beta=betatwg[`i',1..2]
		matrix chitwg[`i',1]=beta*syminv(SIGMAtwg)*beta'
		matrix beta=betapfd[`i',1..2]
		matrix chipfd[`i',1]=beta*syminv(SIGMApfd)*beta'
		matrix beta=betapwg[`i',1..2]
		matrix chipwg[`i',1]=beta*syminv(SIGMApwg)*beta'
        local i=`i'+1
                }
end
qui doit

svmat chitfd
svmat chitwg
svmat chipfd
svmat chipwg

count if chitfd>0.95620257
di r(N)/300
count if chitwg>66.747103
di r(N)/300
count if chipfd>4.389416
di r(N)/300
count if chipwg>86.452602
di r(N)/300

save,replace









