new, 600000;

library optmum;
#include optmum.ext;
optset;

open f1=c:\papers\arch\jan2002\dta\pboot;			/* Matrix of data; m in the first col, var(m) in the remaining cols + numyear */

x      =readr(f1,rowsf(f1));
f1     =close(f1);

dim=cols(x)-1;
T=x[1,cols(x)];

m     =x[.,1];
var   =x[.,2:dim]; 						@ Weighting matrix - Variance matrix for optimal mindist @

@ Starting parameters @

	b0                =zeros(3,1);
	b0[1]             =-0.25;	
	b0[2]             =0.0388;
	b0[3]             =0.0646;

__title = "Error-Components Model";
__row=0;
__miss=1;

{b,fun,grad,ok} = optmum(&cov,b0);							@ Optimisation procedure @
{dfb} = gradfd(&fcn,b);										@ Gradient of covariances at minimum - df/db @

covth=eye(3);							    		@ Covariances of parameters under EWMD @

teta = b[1]; 
zt   = b[2]; 
et   = b[3];

save b = zt;
system;
end;


@ Minimum Distance Procedure @
proc cov(b);
local fmm,f;
fmm=fcn(b);
f=(m-fmm)'*(m-fmm);		@ m is vector of actual covariances - fmm is implied covariances @
retp(f);
endp;
@ Gradient Procedure  - defines implied covariance structure from hypothesised model @
proc fcn(b);
local teta,zt,et,dif,j,i,fm;

	teta = b[1]; zt = b[2]; et = b[3];

dif  =zeros(T-1,T-1);

	j=1;
	do while j<=T-1;
		dif[j,j]=zt+2*(1-teta+teta^2)*et;
	j=j+1;
	endo;
	j=2;
	do while j<=T-1;
		dif[j-1,j]=-(1-teta)^2*et;
	j=j+1;
	endo;
	j=3;
	do while j<=T-1;
		dif[j-2,j]=-teta*et;
	j=j+1;
	endo;

i=2;
do while i<=T-1;
j=i;
do while j<=T-1;
	dif[j,i-1]=dif[i-1,j];
j=j+1;
endo;
i=i+1;
endo;

fm=vech(dif);
retp(fm);
endp;
end;

