new, 600000;

library optmum;
#include optmum.ext;
optset;

/*0 if whole sample, 1 high-school dropout, 2 high-school graduate, 3 college graduate */
sample=1; 

if sample==0;
open f1=c:\papers\arch\feb2002\edu;			/* Matrix of data; m in the first col, var(m) in the remaining cols + numyear */
elseif sample==1;
open f1=c:\papers\arch\feb2002\edu1;			/* Matrix of data; m in the first col, var(m) in the remaining cols + numyear */
elseif sample==2;
open f1=c:\papers\arch\feb2002\edu2;			/* Matrix of data; m in the first col, var(m) in the remaining cols + numyear */
elseif sample==3;
open f1=c:\papers\arch\feb2002\edu3;			/* Matrix of data; m in the first col, var(m) in the remaining cols + numyear */
endif;

x      =readr(f1,rowsf(f1));
f1     =close(f1);

dim=cols(x)-1;
T=x[1,cols(x)];

m     =x[.,1];
var   =x[.,2:dim]; 						@ Weighting matrix - Variance matrix for optimal mindist @

@ Starting parameters @

exclude_first_z=1;
exclude_first_e=0;
exclude_last_z=1;
exclude_last_e=0;

if exclude_first_z==0 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	b0                =zeros(2*T,1);
	b0[1]             =0.15;	
	b0[2:T]           =0.03*ones(T-1,1);
	b0[T+1:rows(b0)]  =0.06*ones(T,1);
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	b0                =zeros(2*T-1,1);
	b0[1]             =0.15;	
	b0[2:T-1]         =0.03*ones(T-2,1);
	b0[T:rows(b0)]    =0.06*ones(T,1);
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==1 and exclude_last_e==0;
	b0                =zeros(2*T-2,1);
	b0[1]             =0.15;	
	b0[2:T-2]         =0.03*ones(T-3,1);
	b0[T-1:rows(b0)]  =0.06*ones(T,1);
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==0;
	b0                =zeros(2*T-2,1);
	b0[1]             =0.15;	
	b0[2:T-1]         =0.03*ones(T-2,1);
	b0[T:rows(b0)]    =0.06*ones(T-1,1);
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==1 and exclude_last_e==1;
	b0                =zeros(2*T-4,1);
	b0[1]             =-0.15;	
	b0[2:T-2]         =0.06*ones(T-3,1);
	b0[T-1:rows(b0)]  =0.06*ones(T-2,1);
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==1;
	b0                =zeros(2*T-3,1);
	b0[1]             =0.15;	
	b0[2:T-1]         =0.03*ones(T-2,1);
	b0[T:rows(b0)]    =0.06*ones(T-2,1);
endif;

__title = "Error-Components Model";
__row=0;
__miss=1;

{b,fun,grad,ok} = optmum(&cov,b0);							@ Optimisation procedure @
{dfb} = gradfd(&fcn,b);										@ Gradient of covariances at minimum - df/db @

covth=invpd(dfb'*dfb)*dfb'*var*dfb*invpd(dfb'*dfb);	    		@ Covariances of parameters under EWMD @
fmn	 =fcn(b);												@ Value of covariances at minimum @
ssd  =(m-fmn)'*(m-fmn);				    					@ Sum of Squared Deviations @
df   =rows(m) - rank(dfb);									@ Degrees of freedom @
seth =sqrt(diag(covth));									@ Standard Errors @

A=dfb*invpd(dfb'*dfb)*dfb';
W=eye(rows(A))-A;
mf=(m-fmn)'*pinv(W*var*W')*(m-fmn);

prb  =cdfchic(mf,df);										@ P-value of test @

if exclude_first_z==0 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	teta = b[1]; zt = (b[2:T]); et = b[T+1:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	teta = b[1]; zt = (b[2:T-1]); et = b[T:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==1 and exclude_last_e==0;
	teta = b[1]; zt = (b[2:T-2]); et = b[T-1:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==0;
	teta = b[1]; zt = (b[2:T-1]); et = b[T:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==1 and exclude_last_e==1;
	teta = b[1]; zt = (b[2:T-2]); et = b[T-1:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==1;
	teta = b[1]; zt = (b[2:T-1]); et = b[T:rows(b0)];
endif;

if sample==0;
output file=c:\papers\arch\feb2002\taba3_0.out reset;
elseif sample==1;
output file=c:\papers\arch\feb2002\taba3_1.out reset;
elseif sample==2;
output file=c:\papers\arch\feb2002\taba3_2.out reset;
elseif sample==3;
output file=c:\papers\arch\feb2002\taba3_3.out reset;
endif;

print __title;
print "ok "                      ok;
print "function minimum"         fun;
print "X2      "         mf;
print "SSD     "         ssd;
print "DF      "         df;
print "Prob    "         prb;
print;
print "variable        coefficient       std error       t-stat";
print "teta      "        teta     seth[1] teta/seth[1];
if exclude_first_z==0 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	print;
	print "Var. perm. shock          S.E.            T-stat";
	print zt~seth[2:T]~zt./(seth[2:T]);
@	print et~seth[T+1:rows(b0)]~et./seth[T+1:rows(b0)];@
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	print;
	print "Var. perm. shock          S.E.            T-stat";
	print zt~seth[2:T-1]~zt./(seth[2:T-1]);
@	print et~seth[T:rows(b0)]~et./seth[T:rows(b0)];@
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==1 and exclude_last_e==0;
	print;
	print "Var. perm. shock          S.E.            T-stat";
	print zt~seth[2:T-2]~zt./(seth[2:T-2]);
@	print et~seth[T-1:rows(b0)]~et./seth[T-1:rows(b0)];@
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==0;
	print;
	print "Var. perm. shock          S.E.            T-stat";
	print zt~seth[2:T-1]~zt./(seth[2:T-1]); 
@	print et~seth[T:rows(b0)]~et./seth[T:rows(b0)];@
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==1 and exclude_last_e==1;
	print;
	print "Var. perm. shock          S.E.            T-stat";
	print zt~seth[2:T-2]~zt./(seth[2:T-2]);
@	print et~seth[T-1:rows(b0)]~et./seth[T-1:rows(b0)];@
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==1;
	print;
	print "Var. perm. shock          S.E.            T-stat";
	print zt~seth[2:T-1]~zt./(seth[2:T-1]);
@	print et~seth[T:rows(b0)]~et./seth[T:rows(b0)];@
endif;
output file=c:\papers\arch\feb2002\mindist.out off;
end;


@ Minimum Distance Procedure @
proc cov(b);
local fmm,f;
fmm=fcn(b);
f=(m-fmm)'*(m-fmm);		@ m is vector of actual covariances - fmm is implied covariances @
retp(f);
endp;

@ Gradient Procedure  - defines implied covariance structure from hypothesised model @
proc fcn(b);
local teta,zt,et,dif,j,i,fm;

if     exclude_first_z==0 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	teta = b[1]; zt = (b[2:T]); et = b[T+1:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	teta = b[1]; zt = (b[2:T-1]); et = b[T:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==1 and exclude_last_e==0;
	teta = b[1]; zt = (b[2:T-2]); et = b[T-1:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==0;
	teta = b[1]; zt = (b[2:T-1]); et = b[T:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==1 and exclude_last_e==1;
	teta = b[1]; zt = (b[2:T-2]); et = b[T-1:rows(b0)];
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==1;
	teta = b[1]; zt = (b[2:T-1]); et = b[T:rows(b0)];
endif;

dif  =zeros(T-1,T-1);

if exclude_first_z==0 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	dif[1,1]=zt[1]+et[2]+(1-teta)^2*et[1];
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	dif[1,1]=zt[1]+et[2]+(1-teta)^2*et[1];
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==1 and exclude_last_e==0;
	dif[1,1]=zt[1]+et[2]+(1-teta)^2*et[1];
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==0;
	dif[1,1]=zt[1]+et[1]+(1-teta)^2*et[1];
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==1 and exclude_last_e==1;
	dif[1,1]=zt[1]+et[1]+(1-teta)^2*et[1];
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==1;
	dif[1,1]=zt[1]+et[1]+(1-teta)^2*et[1];
endif;

if exclude_first_z==0 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	j=2;
	do while j<=T-1;
		dif[j,j]=zt[j]+et[j+1]+(1-teta)^2*et[j]+teta^2*et[j-1];
	j=j+1;
	endo;
	j=2;
	do while j<=T-1;
		dif[j-1,j]=-(1-teta)*et[j]+teta*(1-teta)*et[j-1];
	j=j+1;
	endo;
	j=3;
	do while j<=T-1;
		dif[j-2,j]=-teta*et[j-1];
	j=j+1;
	endo;
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==0 and exclude_last_e==0;
	j=2;
	do while j<=T-1;
		dif[j,j]=zt[j-1]+et[j+1]+(1-teta)^2*et[j]+teta^2*et[j-1];
	j=j+1;
	endo;
	j=2;
	do while j<=T-1;
		dif[j-1,j]=-(1-teta)*et[j]+teta*(1-teta)*et[j-1];
	j=j+1;
	endo;
	j=3;
	do while j<=T-1;
		dif[j-2,j]=-teta*et[j-1];
	j=j+1;
	endo;
elseif exclude_first_z==1 and exclude_first_e==0 and exclude_last_z==1 and exclude_last_e==0;
	j=2;
	do while j<=T-2;
		dif[j,j]=zt[j-1]+et[j+1]+(1-teta)^2*et[j]+teta^2*et[j-1];
	j=j+1;
	endo;
	dif[T-1,T-1]=zt[T-3]+et[T]+(1-teta)^2*et[T-1]+teta^2*et[T-2];	
	j=2;
	do while j<=T-1;
		dif[j-1,j]=-(1-teta)*et[j]+teta*(1-teta)*et[j-1];
	j=j+1;
	endo;
	j=3;
	do while j<=T-1;
		dif[j-2,j]=-teta*et[j-1];
	j=j+1;
	endo;
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==0;
	dif[2,2]=zt[1]+et[2]+(1-teta)^2*et[1]+teta^2*et[1];
	j=3;
	do while j<=T-1;
		dif[j,j]=zt[j-1]+et[j]+(1-teta)^2*et[j-1]+teta^2*et[j-2];
	j=j+1;
	endo;
	dif[1,2]=-(1-teta)*et[1]+teta*(1-teta)*et[1];
	j=3;
	do while j<=T-1;
		dif[j-1,j]=-(1-teta)*et[j-1]+teta*(1-teta)*et[j-2];
	j=j+1;
	endo;
	j=3;
	do while j<=T-1;
		dif[j-2,j]=-teta*et[j-2];
	j=j+1;
	endo;
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==1 and exclude_last_e==1;
	dif[2,2]=zt[1]+et[2]+(1-teta)^2*et[1]+teta^2*et[1];
	j=3;
		do while j<=T-2;
		dif[j,j]=zt[j-1]+et[j]+(1+teta)^2*et[j-1]+teta^2*et[j-2];
	j=j+1;
	endo;
	dif[T-1,T-1]=zt[T-3]+et[T-2]+(1+teta)^2*et[T-2]+teta^2*et[T-3];
	dif[1,2]=-(1-teta)*et[1]+teta*(1-teta)*et[1];
	j=3;
	do while j<=T-1;
		dif[j-1,j]=-(1-teta)*et[j-1]+teta*(1-teta)*et[j-2];
	j=j+1;
	endo;
	j=3;
	do while j<=T-1;
		dif[j-2,j]=-teta*et[j-2];
	j=j+1;
	endo;
elseif exclude_first_z==1 and exclude_first_e==1 and exclude_last_z==0 and exclude_last_e==1;
	dif[2,2]=zt[1]+et[2]+(1-teta)^2*et[1]+teta^2*et[1];
	j=3;
		do while j<=T-2;
		dif[j,j]=zt[j-1]+et[j]+(1+teta)^2*et[j-1]+teta^2*et[j-2];
	j=j+1;
	endo;
	dif[T-1,T-1]=zt[T-2]+et[T-2]+(1+teta)^2*et[T-2]+teta^2*et[T-3];
	dif[1,2]=-(1-teta)*et[1]+teta*(1-teta)*et[1];
	j=3;
	do while j<=T-1;
		dif[j-1,j]=-(1-teta)*et[j-1]+teta*(1-teta)*et[j-2];
	j=j+1;
	endo;
	j=3;
	do while j<=T-1;
		dif[j-2,j]=-teta*et[j-2];
	j=j+1;
	endo;
endif;

i=2;
do while i<=T-1;
j=i;
do while j<=T-1;
	dif[j,i-1]=dif[i-1,j];
j=j+1;
endo;
i=i+1;
endo;

fm=vech(dif);
retp(fm);
endp;
end;