clear
drop _all
set matsize 800
cd c:\papers\arch\feb2002\bootdata

*********Table V
*********This calculates p-values for time and age effects/for just time effects

scalar time_age=1 /*time_age=0 just time dummies, time_age=1 time dummies & age*/

u boot_p1,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b223,matrix(data)
	}
else
	{
	mkmat b23-b223,matrix(data)
	}

drop b11-i
matrix cov1=(1/_N)*data'*data-(1/_N)*(1/_N)*data'*i*i'*data

u boot_p2,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b223,matrix(data)
	}
else
	{
	mkmat b23-b223,matrix(data)
	}

drop b11-i
matrix cov2=(1/_N)*data'*data-(1/_N)*(1/_N)*data'*i*i'*data

u boot_p3,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b223,matrix(data)
	}
else
	{
	mkmat b23-b223,matrix(data)
	}

drop b11-i
matrix cov3=(1/_N)*data'*data-(1/_N)*(1/_N)*data'*i*i'*data

u bhat_perm
mkmat educ1,matrix(bhat1)
mkmat educ2,matrix(bhat2)
mkmat educ3,matrix(bhat3)

if time_age==0 {
	matrix test1=bhat1[5..23,1]'*syminv(cov1)*bhat1[5..23,1]
	matrix test2=bhat2[5..23,1]'*syminv(cov2)*bhat2[5..23,1]
	matrix test3=bhat3[5..23,1]'*syminv(cov3)*bhat3[5..23,1]
	}
else
	{
	matrix test1=bhat1[3..23,1]'*syminv(cov1)*bhat1[3..23,1]
	matrix test2=bhat2[3..23,1]'*syminv(cov2)*bhat2[3..23,1]
	matrix test3=bhat3[3..23,1]'*syminv(cov3)*bhat3[3..23,1]
	}

u boot_p1,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b223,matrix(data)
	}
else
	{
	mkmat b23-b223,matrix(data)
	}

drop b11-i

matrix bbar1=(data'*i)/500
matrix bbar1mat=bbar1 # i'
matrix stat=(data'-bbar1mat)

matrix h=J(500,1,0)

cap program drop doit
program def doit
	  local i=1
        while `i' < 501 {
		matrix h`i'=stat[1...,`i']'*syminv(cov1)*stat[1...,`i']
		matrix h[`i',1]=h`i'[1,1]
		matrix drop h`i'
	  local i=`i'+1
                }
end
qui doit

svmat h
svmat test1
egen test=mean(test11)
drop test11
gsort -h

count if test<h1
di r(N)/_N


u boot_p2,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b223,matrix(data)
	}
else
	{
	mkmat b23-b223,matrix(data)
	}

drop b11-i

matrix bbar2=(data'*i)/500
matrix bbar2mat=bbar2 # i'
matrix stat=(data'-bbar2mat)

matrix h=J(500,1,0)

cap program drop doit
program def doit
	  local i=1
        while `i' < 501 {
		matrix h`i'=stat[1...,`i']'*syminv(cov2)*stat[1...,`i']
		matrix h[`i',1]=h`i'[1,1]
		matrix drop h`i'
	  local i=`i'+1
                }
end
qui doit

svmat h
svmat test2
egen test=mean(test21)
drop test21
gsort -h

count if test<h1
di r(N)/_N


u boot_p3,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b223,matrix(data)
	}
else
	{
	mkmat b23-b223,matrix(data)
	}

drop b11-i

matrix bbar3=(data'*i)/500
matrix bbar3mat=bbar3 # i'
matrix stat=(data'-bbar3mat)

matrix h=J(500,1,0)

cap program drop doit
program def doit
	  local i=1
        while `i' < 501 {
		matrix h`i'=stat[1...,`i']'*syminv(cov3)*stat[1...,`i']
		matrix h[`i',1]=h`i'[1,1]
		matrix drop h`i'
	  local i=`i'+1
                }
end
qui doit

svmat h
svmat test3
egen test=mean(test31)
drop test31
gsort -h

count if test<h1
di r(N)/_N




u boot_t1,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b225,matrix(data)
	}
else
	{
	mkmat b23-b225,matrix(data)
	}

drop b11-i
matrix cov1=(1/_N)*data'*data-(1/_N)*(1/_N)*data'*i*i'*data

u boot_t2,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b225,matrix(data)
	}
else
	{
	mkmat b23-b225,matrix(data)
	}

drop b11-i
matrix cov2=(1/_N)*data'*data-(1/_N)*(1/_N)*data'*i*i'*data

u boot_t3,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b225,matrix(data)
	}
else
	{
	mkmat b23-b225,matrix(data)
	}

drop b11-i
matrix cov3=(1/_N)*data'*data-(1/_N)*(1/_N)*data'*i*i'*data

u bhat_trans
mkmat educ1,matrix(bhat1)
mkmat educ2,matrix(bhat2)
mkmat educ3,matrix(bhat3)

if time_age==0 {
	matrix test1=bhat1[5..25,1]'*syminv(cov1)*bhat1[5..25,1]
	matrix test2=bhat2[5..25,1]'*syminv(cov2)*bhat2[5..25,1]
	matrix test3=bhat3[5..25,1]'*syminv(cov3)*bhat3[5..25,1]
	}
else
	{
	matrix test1=bhat1[3..25,1]'*syminv(cov1)*bhat1[3..25,1]
	matrix test2=bhat2[3..25,1]'*syminv(cov2)*bhat2[3..25,1]
	matrix test3=bhat3[3..25,1]'*syminv(cov3)*bhat3[3..25,1]
	}

u boot_t1,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b225,matrix(data)
	}
else
	{
	mkmat b23-b225,matrix(data)
	}

drop b11-i

matrix bbar1=(data'*i)/500
matrix bbar1mat=bbar1 # i'
matrix stat=(data'-bbar1mat)

matrix h=J(500,1,0)

cap program drop doit
program def doit
	  local i=1
        while `i' < 501 {
		matrix h`i'=stat[1...,`i']'*syminv(cov1)*stat[1...,`i']
		matrix h[`i',1]=h`i'[1,1]
		matrix drop h`i'
	  local i=`i'+1
                }
end
qui doit

svmat h
svmat test1
egen test=mean(test11)
drop test11
gsort -h

count if test<h1
di r(N)/_N


u boot_t2,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b225,matrix(data)
	}
else
	{
	mkmat b23-b225,matrix(data)
	}

drop b11-i

matrix bbar2=(data'*i)/500
matrix bbar2mat=bbar2 # i'
matrix stat=(data'-bbar2mat)

matrix h=J(500,1,0)

cap program drop doit
program def doit
	  local i=1
        while `i' < 501 {
		matrix h`i'=stat[1...,`i']'*syminv(cov2)*stat[1...,`i']
		matrix h[`i',1]=h`i'[1,1]
		matrix drop h`i'
	  local i=`i'+1
                }
end
qui doit

svmat h
svmat test2
egen test=mean(test21)
drop test21
gsort -h

count if test<h1
di r(N)/_N


u boot_t3,clear
gen i=1
mkmat i,matrix(i)
if time_age==0 {
	mkmat b25-b225,matrix(data)
	}
else
	{
	mkmat b23-b225,matrix(data)
	}

drop b11-i

matrix bbar3=(data'*i)/500
matrix bbar3mat=bbar3 # i'
matrix stat=(data'-bbar3mat)

matrix h=J(500,1,0)

cap program drop doit
program def doit
	  local i=1
        while `i' < 501 {
		matrix h`i'=stat[1...,`i']'*syminv(cov3)*stat[1...,`i']
		matrix h[`i',1]=h`i'[1,1]
		matrix drop h`i'
	  local i=`i'+1
                }
end
qui doit

svmat h
svmat test3
egen test=mean(test31)
drop test31
gsort -h

count if test<h1
di r(N)/_N
